/*
 * $COPYRIGHT$
 * $Id: ComponentManager.java,v 1.5 2001/07/11 21:40:22 borzy Exp $
 *
 * Date        Author               Changes
 * May 22 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.util.Vector;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JButton;
/**
 * Class meant apply the new settings to HyperPanel components.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.5 $ $Date: 2001/07/11 21:40:22 $
 * @see String
 */   
public class ComponentManager extends Vector {
    private Vector _components = new Vector();
    private Vector _proxyPanelComponents = new Vector();
    private Vector _navigationBarComponents = new Vector();

    protected void addComponent(Component c) {
        _components.addElement(c);
    }

    protected void addProxyPanelComponent(Component c) {
        _proxyPanelComponents.addElement(c);
    }

    protected void addNavigationBarComponent(Component c) {
        _navigationBarComponents.addElement(c);
    }

    protected void updateComponents() {
        for (int i=0; i < _components.size(); i++) {
            ((Component)_components.elementAt(i)).setFont(HyperPanel.ch.getMenuFont());
        }
    }

    protected void updateProxyPanelComponents(boolean editable) {
        for (int i=0; i < _proxyPanelComponents.size(); i++) {
            ((Component)_proxyPanelComponents.elementAt(i)).setEnabled(editable);
        }
    }

    protected void updateNavigationBarComponents() {
        String[] navButtons = HyperPanel.tokenize(HyperPanel.navigationbar);
        for (int i = 0; i < navButtons.length; i++) {
            String key = navButtons[i];
            if (HyperPanel.ch.getButtonDisplay().equals("TO")) {
                ((JButton)_navigationBarComponents.elementAt(i)).setIcon(null);
                ((JButton)_navigationBarComponents.elementAt(i)).setText(MyResources.getTextValue(key + "Label"));
            }
            else if (HyperPanel.ch.getButtonDisplay().equals("T+I")) {
                ((JButton)_navigationBarComponents.elementAt(i)).setIcon(MyResources.getImageIcon(key + "Image"));
                ((JButton)_navigationBarComponents.elementAt(i)).setText(MyResources.getTextValue(key + "Label"));
            }
            else if (HyperPanel.ch.getButtonDisplay().equals("IO")) {
                ((JButton)_navigationBarComponents.elementAt(i)).setIcon(MyResources.getImageIcon(key + "Image"));
                ((JButton)_navigationBarComponents.elementAt(i)).setText("");
            }
        }
    }
}

