/*
 * $COPYRIGHT$
 * $Id: ConfCache.java,v 1.4 2002/01/21 13:02:25 borzy Exp $
 *
 * Date        Author               Changes
 * Aug 2 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.util.ArrayList;
import java.awt.RenderingHints;
import org.media.hyperpad.conf.ConfigHandler;
/**
 * Class meant to hold the configurations for syntax highlight used by HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.4 $ $Date: 2002/01/21 13:02:25 $
 * @see String
 */        
public class ConfCache extends ArrayList {
    public final int generalFont = 0;
    public final int generalColor = 1;
    public final int keywordFont = 2;
    public final int keywordColor = 3;
    public final int stringFont = 4;
    public final int stringColor = 5;
    public final int commentFont = 6;
    public final int commentColor = 7;
    public final int numericFont = 8;
    public final int numericColor = 9;
    public final int isAntiAliasing = 10;
    public final int isLineWrap = 11;
    public final int ANTI_ALIASED_RENDERING = 12;
    public final int DEFAULT_RENDERING = 13;

    public ConfCache() {
        inicialize();
    }

    protected void inicialize() {
        ConfigHandler ch = new ConfigHandler(HyperPanel.XMLpath);
        this.add(generalFont, ch.getGeneralFont());
        this.add(generalColor, ch.getGeneralColor());
        this.add(keywordFont, ch.getKeywordFont());
        this.add(keywordColor, ch.getKeywordColor());
        this.add(stringFont, ch.getStringFont());
        this.add(stringColor, ch.getStringColor());
        this.add(commentFont, ch.getCommentFont());
        this.add(commentColor, ch.getCommentColor());
        this.add(numericFont, ch.getNumericFont());
        this.add(numericColor, ch.getNumericColor());
        this.add(isAntiAliasing, new Boolean(ch.getAntiAliasingStatus()));
        this.add(isLineWrap, new Boolean(ch.getLineWrapStatus()));
        
       RenderingHints antiAliasing = new 
           RenderingHints(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
       antiAliasing.put(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
       antiAliasing.put(RenderingHints.KEY_DITHERING, RenderingHints.VALUE_DITHER_ENABLE);
       antiAliasing.put(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
       antiAliasing.put(RenderingHints.KEY_ALPHA_INTERPOLATION, RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
       antiAliasing.put(RenderingHints.KEY_COLOR_RENDERING, RenderingHints.VALUE_COLOR_RENDER_QUALITY);
       antiAliasing.put(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
       RenderingHints defaultRender = new RenderingHints(RenderingHints.KEY_ANTIALIASING,
                                                         RenderingHints.VALUE_ANTIALIAS_OFF);
       this.add(ANTI_ALIASED_RENDERING, antiAliasing);
       this.add(DEFAULT_RENDERING, defaultRender);
    }
}
