/*
 * $COPYRIGHT$
 * $Id: DocListener.java,v 1.3 2001/06/19 09:01:51 borzy Exp $
 *
 * Date        Author               Changes
 * May 28 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import javax.swing.text.Element;
import javax.swing.text.AttributeSet;
import javax.swing.text.AbstractDocument;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.html.HTMLDocument;
import java.util.Enumeration;
/**
 * Class needed by HyperPad for syntax highlighting.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.3 $ $Date: 2001/06/19 09:01:51 $
 * @see String
 */
public class DocListener implements DocumentListener {

    public void changedUpdate( DocumentEvent de ) {
        ix( "change", de);
    }

    public void insertUpdate( DocumentEvent de ) {
        ix( "insert", de);
    }

    public void removeUpdate( DocumentEvent de ) {
        ix( "remove", de);
    }

    public void ix (String what, DocumentEvent de) {
        try {
        HTMLDocument ad = (HTMLDocument)de.getDocument();
        Element el = ad.getParagraphElement( de.getOffset());
        System.out.println (what + ":" + ad.getText( de.getOffset(), de.getLength()));
        ((AbstractDocument.AbstractElement) el).dump(System.out, 6);
        //parseDocument (ad);
        //parseElementTree (el, 0);
        if( de.getChange(el) != null )
            change( de.getChange(el) );
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void iy (String what, DocumentEvent de) {
        try {
        HTMLDocument ad = (HTMLDocument)de.getDocument();
        Element el = ad.getParagraphElement( de.getOffset());
        System.out.println (what + ":" + ad.getText( de.getOffset(), de.getLength()));
        String text = ad.getText( de.getOffset(), de.getLength());
        if ( text.toLowerCase().equals("print")){
            ad.insertBeforeEnd(el, "<font color=\"green\"><i>" + text + "</i></font>");
            //  throw new AbstractDocument.DefaultDocumentEvent(de.getOffset()+1, 5, 
            //                                                DocumentEvent.EventType.INSERT);
        }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }


    public void change(DocumentEvent.ElementChange ec) {
        Element[] elAdd = ec.getChildrenAdded();
        Element[] elRem = ec.getChildrenRemoved();
        if( elAdd != null && elAdd.length >0){
            System.out.println("   added: ");
            parseElementArray( elAdd );
        }
        if( elRem != null  && elRem.length >0){
            System.out.println("   removed: ");
            parseElementArray( elRem );
        }
    }
    
    public void parseDocument(HTMLDocument d) {
        for (int i= 0; i < d.getRootElements().length ;i ++){
            parseElementTree (d.getRootElements()[i], 0);
        }
    }

    public void parseElementArray(Element[] e) {
        Element el;
        AttributeSet attr;
        Enumeration en;
        Object key;
        System.out.print("\n");
        for (int j = 0 ; j < e.length ; j++){
            System.out.print("       " + e[j].getName());
            attr = e[j].getAttributes();
            en =attr.getAttributeNames();
            System.out.print(" [");
            while ( en.hasMoreElements() ) {
                key= en.nextElement();
                System.out.print(" " + key + "=" + attr.getAttribute(key) + ";");
            }
            System.out.print(" ]\n");
            ((AbstractDocument.AbstractElement) e[j]).dump(System.out, 6);
        }

    }

    public void parseElementTree(Element e, int i) {
        Element el;
        AttributeSet attr;
        Enumeration en;
        System.out.print("\n");
        for (int j = 0 ; j < i ; j++)
            System.out.print(" ");
        System.out.print(e.getName());
        attr = e.getAttributes();
        en =attr.getAttributeNames();
        System.out.print(" [");
        Object key;
        while ( en.hasMoreElements() ) {
            key= en.nextElement();
            System.out.print(" " + key + "=" + attr.getAttribute(key) + ";");
        }
        System.out.print(" ]");
        if ( e instanceof HTMLDocument.RunElement ){
            ((HTMLDocument.RunElement)e).dump(System.out,1);
        }
        // if ( !e.isLeaf() ) {
            for (int cnt = 0; cnt < e.getElementCount(); cnt++)
            parseElementTree(e.getElement(cnt), i+2 );
            //}
        System.out.print("\n");                             
    }
}
