/*
 * $COPYRIGHT$
 * $Id: ErrorPrintStream.java,v 1.1 2002/06/04 18:16:40 borzy Exp $
 *
 * Date        Author               Changes
 * Jun 06 2002 Borsos Szabolcs      Created
 */
package org.media.hyperpad;

import java.io.PrintStream;
import java.io.OutputStream;
import org.media.hyperpad.conf.*;
import org.media.mn8.mn8Interpreter;

import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;

/**
 * Class meant to display the results witch are returned by mn8.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.1 $ $Date: 2002/06/04 18:16:40 $
 * @see String
 */
public class ErrorPrintStream extends PrintStream {
    final static String RESULT = "result";
    private static ConfigHandler ch = null;
    private static HyperDocument hp;
    static boolean isResult = false;
    
    public ErrorPrintStream(OutputStream out) {
        super(out);
        ch = HyperPanel.ch;
        hp = (HyperDocument) HyperPanel.pane.getDocument();
    }

    public void println(String string) {
        displayResults(string + "\n"); 
    }

    public void print(String string) {
        displayResults(string); 
    }

    private void displayResults(String results) {
        String result = null;
        StringBuffer buffer = new StringBuffer(results);
        for (int i=0; i<buffer.length(); i++) {
            char c = buffer.charAt(i);
            if (c == '<') {
                buffer.deleteCharAt(i);
                buffer.insert(i, "&lt;");
                i += 3;
            }
            else if (c == '>') {
                buffer.deleteCharAt(i);
                buffer.insert(i, "&gt;");
                i += 3;
            }
            else if (c == ' ') {
                buffer.deleteCharAt(i);
                buffer.insert(i, "&nbsp;");
                i += 5;
            }
            else if (c == '\"') {
                buffer.deleteCharAt(i);
                buffer.insert(i, "&quot;");
                i += 5;
            }
            else if (c == '\n') {
                buffer.deleteCharAt(i);
                buffer.insert(i, "<br>");
                i += 3;
            }
            else if (c == '\r') {
                if (buffer.charAt(i+1) == '\n') {
                    buffer.deleteCharAt(i);
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "<br>");
                    i += 2;
                }
                else {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "<br>");
                    i += 3;
                }
            }
        }
        result = buffer.toString();

        if (result.trim().length() != 0) {
            isResult = true;
        }
        try {
            if (isResult) {
                hp.insertString(hp.getLength(), RESULT+result, null);
                HyperPanel.pane.setCaretPosition(hp.getLength());
                isResult = false;
            }
        } catch (Exception ex) {}
    }
}

