/*
 * $COPYRIGHT$
 * $Id: HTMLFilter.java,v 1.1 2001/08/04 22:17:48 borzy Exp $
 *
 * Date        Author               Changes
 * Jun 01 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.io.File;
import javax.swing.filechooser.FileFilter;
/**
 * Class to filter .html, .htm, .shtml files only.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.1 $ $Date: 2001/08/04 22:17:48 $
 * @see String
 */
public class HTMLFilter extends FileFilter {
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }                
        String extension = getExtension(f);
        if (extension.equals("html")) { 
            return true; 
        }
        else if (extension.equals("htm")) { 
            return true; 
        }
        else if (extension.equals("shtml")) { 
            return true; 
        }
        else {
            return false;
        }
    }
    
    public String getDescription() {
        return "HTML, HTM, SHTML files";
    }
    
    private String getExtension(File f) {
        String s = f.getName();
        int i = s.lastIndexOf('.');
        if (i > 0 && i < s.length() - 1) 
            return s.substring(i+1).toLowerCase();
        return "";
    }
}
