/*
 * $COPYRIGHT$
 * $Id: HyperActivKeyListener.java,v 1.14 2002/01/29 14:04:55 borzy Exp $
 *
 * Date        Author               Changes
 * Jul 23 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import java.awt.Font;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.JViewport;
import javax.swing.JScrollPane;
import javax.swing.text.html.HTMLDocument;
import org.media.mn8.mn8Interpreter;
/**
 * Class meant to catch and interpret the key events for interactiv mode.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.14 $ $Date: 2002/01/29 14:04:55 $
 * @see String
 */  
public class HyperActivKeyListener implements KeyListener {
    javax.swing.JTextPane _tp;
    java.util.Vector commands = new java.util.Vector();
    int historyPosition = 0;
    String all, last_command = "";
    
    public HyperActivKeyListener(java.awt.Component comp) {
        _tp = (javax.swing.JTextPane) comp;
        _tp.addKeyListener(this);
        commands.add("");
    }

    public void keyPressed(KeyEvent ke) {
        interpret(ke);
    }

    public void keyReleased(KeyEvent ke) {
    }

    public void keyTyped(KeyEvent ke) {
    }

    private void interpret(KeyEvent ke) {
        try {
            all = _tp.getDocument().getText(0, _tp.getDocument().getLength());
        } catch (Exception e) {
            e.printStackTrace();
        }
        last_command = last_command();
        switch (ke.getKeyCode()) {
        case KeyEvent.VK_RIGHT: 
            break;
        case KeyEvent.VK_LEFT: 
            if (all.lastIndexOf(HyperPanel.prompt)+HyperPanel.prompt.length() == _tp.getCaretPosition()) {
                ke.setKeyCode(0);
            }
            break;
        case KeyEvent.VK_UP:
            ke.setKeyCode(0);
            if (ke.isShiftDown()) {
                JScrollPane jsp = (JScrollPane)HyperPanel.jTabPane.getComponentAt(0);
                JViewport viewport = jsp.getViewport();
                if (viewport.getViewPosition().getY() > 0) {
                    viewport.setViewPosition(new Point(0, (int)viewport.getViewPosition().getY() - 
                             ((Font)HyperPanel.confcache.get(HyperPanel.confcache.generalFont)).getSize()));
                }
            }
            else if (commands.size() != 0 && historyPosition-1 > -1) {
                historyPosition -= 1;
                setCommand(historyPosition);
            }
            break;
        case KeyEvent.VK_DOWN: 
            ke.setKeyCode(0);
            if (ke.isShiftDown()) {
                JScrollPane jsp = (JScrollPane)HyperPanel.jTabPane.getComponentAt(0);
                JViewport viewport = jsp.getViewport();
                if ((int)viewport.getViewPosition().getY() < 
                    ((int)_tp.getSize().getHeight() - (int)viewport.getSize().getHeight())) {
                    viewport.setViewPosition(new Point(0, (int)viewport.getViewPosition().getY() +
                             ((Font)HyperPanel.confcache.get(HyperPanel.confcache.generalFont)).getSize()));
                }
            }
            else if (commands.size() != 0 && historyPosition+1 < commands.size()) {
                historyPosition += 1;
                setCommand(historyPosition);
            }
            break;
        case KeyEvent.VK_BACK_SPACE:
            if (all.lastIndexOf(HyperPanel.prompt)+HyperPanel.prompt.length() == _tp.getCaretPosition()) {
                _tp.replaceSelection("|");
            }
            break;
        case KeyEvent.VK_ENTER:
            HyperDocument hp = (HyperDocument)_tp.getDocument();
            if (last_command.length() == 0) {
                _tp.setCaretPosition(_tp.getDocument().getLength());
                _tp.replaceSelection("\n");
                hp.insertPrompt();
            }
            else if (last_command.trim().endsWith("\\") || hp.bracketsNR != 0) {
                _tp.setCaretPosition(_tp.getDocument().getLength());
                _tp.replaceSelection("\n");
            }
            else {
                _tp.setCaretPosition(_tp.getDocument().getLength());
                addToList(last_command);
                syncronize();
                HyperPanel.running(true);
                HyperPanel.makeExecute(last_command + "\n");
                last_command = "";
            }
            ke.setKeyCode(0);
            break;
        case KeyEvent.VK_TAB:
            org.media.hyperpad.conf.ConfigHandler ch = 
                new org.media.hyperpad.conf.ConfigHandler(HyperPanel.XMLpath);
            if (ch.getReplaceMode()) {
                for (int i = 0; i < Integer.valueOf(ch.getSpaceNumber()).intValue(); i++) {
                    _tp.replaceSelection(" ");
                }
                ke.setKeyCode(0);
            }
            break;
        case KeyEvent.VK_HOME: _tp.setCaretPosition(all.lastIndexOf(HyperPanel.prompt) +
                                                    HyperPanel.prompt.length());
            ke.setKeyCode(0);
            break;
        case KeyEvent.VK_END: _tp.setCaretPosition(_tp.getDocument().getLength());
            break;
        case KeyEvent.VK_PAGE_UP:
            if (ke.isShiftDown()) {
                JScrollPane jsp = (JScrollPane)HyperPanel.jTabPane.getComponentAt(0);
                JViewport viewport = jsp.getViewport();
                if (viewport.getViewPosition().getY() > 0) {
                    viewport.setViewPosition(new Point(0, (int)viewport.getViewPosition().getY() - 
                             (10 * ((Font)HyperPanel.confcache.get(HyperPanel.confcache.generalFont)).getSize())));
                }
            }
            ke.setKeyCode(0);
            break;
        case KeyEvent.VK_PAGE_DOWN:
            if (ke.isShiftDown()) {
                JScrollPane jsp = (JScrollPane)HyperPanel.jTabPane.getComponentAt(0);
                JViewport viewport = jsp.getViewport();
                if ((int)viewport.getViewPosition().getY() < 
                    ((int)_tp.getSize().getHeight() - (int)viewport.getSize().getHeight())) {
                    viewport.setViewPosition(new Point(0, (int)viewport.getViewPosition().getY() +
                             (10 * ((Font)HyperPanel.confcache.get(HyperPanel.confcache.generalFont)).getSize())));
                }
            }
            ke.setKeyCode(0);
            break;
        case KeyEvent.VK_ESCAPE:
            ke.setKeyCode(0);
            int choice = HyperOptionPane.showDialog(HyperPanel.frame, 
                                                    HyperPanel.getResourceString("exitWindowTitle"),
                                                    HyperPanel.getResourceString("exitMessage"),
                                                    HyperOptionPane.YES_NO_OPTION);
            if (choice == HyperOptionPane.YES) {
                System.exit(0);
            }
            else {
                _tp.requestFocus();
            }
            break;
        }
    }
    
    private String last_command() {
        try {
            int a = all.lastIndexOf(HyperPanel.prompt) + HyperPanel.prompt.length();
            int b = all.length();
            last_command = all.substring(a, b);
            return last_command;
        }
        catch (Exception e) {
            return "";
        }
    }

    private void setCommand(int index) {
        String command = (String)commands.elementAt(index);
        int a = all.lastIndexOf(HyperPanel.prompt) + HyperPanel.prompt.length();
        int b = all.length();
        _tp.select(a, b);
        _tp.replaceSelection(command);
    }

    private void addToList(String command) {
        commands.add(commands.size()-1, command);
        org.media.hyperpad.conf.ConfigHandler ch = 
            new org.media.hyperpad.conf.ConfigHandler(HyperPanel.XMLpath);
        if (commands.size() > Integer.valueOf(ch.getHistoryLength()).intValue()+1) {
            commands.remove(0);
        }
        historyPosition = commands.size()-1;
    }
    
    private void syncronize() {
        try {
            HTMLDocument hdoc = (HTMLDocument)HyperPanel.editorpane.getDocument();
            HyperPanel.editorpane.setCaretPosition(hdoc.getLength());
            if (!hdoc.getText(0, hdoc.getLength()).endsWith("\n") && hdoc.getLength() != 0) {
                HyperPanel.editorpane.replaceSelection("\n" + (String)commands.elementAt(commands.size()-2) + "\n");
            }
            else {
                HyperPanel.editorpane.replaceSelection((String)commands.elementAt(commands.size()-2) + "\n");
            }
            if (HyperPanel.sourceDocSaved) {
                HyperPanel.sourceDocSaved = false;
                HyperPanel.updateSaveButton();
            }
        } catch (Exception ex) {}
    }
}
