/*
 * $COPYRIGHT$
 * $Id: HyperEditorKit.java,v 1.7 2001/07/25 11:46:10 borzy Exp $
 *
 * Date        Author               Changes
 * May 28 2001 Borsos Szabolcs      Created
 */
package org.media.hyperpad;

import java.awt.Color;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.html.StyleSheet;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.StyleConstants;
import javax.swing.text.Document;
/**
 * Class needed by HyperPad for syntax highlighting.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.7 $ $Date: 2001/07/25 11:46:10 $
 * @see String
 */
public class HyperEditorKit extends HTMLEditorKit {
    public Parser parser = new HyperParseDelegator();
    int pane = 0;
    
    public HyperEditorKit(int arg) {
        pane = arg;
    }

    public Document createDefaultDocument() {
        javax.swing.text.html.HTMLDocument doc = null;
        if (pane == 0) {
            doc= new HyperDocument( getDefaultStyle() );
            HyperPanel.hek = this;
        }
        else if (pane == 1) {
            doc= new HyperSourceDocument( getDefaultStyle() );
            HyperPanel.shek = this;
        }
        doc.setParser(getParser());
        doc.setAsynchronousLoadPriority(4);
        return doc;
    }

    protected Parser getParser() {
        return   parser;
    }

    public static StyleSheet getDefaultStyle() {
        StyleSheet ss = new StyleSheet();
        String generalFontName = HyperPanel.ch.getGeneralFont().getName();
        int generalFontSize = HyperPanel.ch.getGeneralFont().getSize();
        String fontColor = hexColorValue(HyperPanel.ch.getGeneralColor());
        String backgroundColor = hexColorValue(HyperPanel.ch.getGeneralBgColor());
        ss.addRule("body { font-family: " + generalFontName + "; " +
                   "font-size: " + generalFontSize + "pt; " +
                   "color: " + fontColor + "; " +
                   "background-color: " + backgroundColor + "; " +
                   "}"
                   );
        HyperPanel.pane.setBackground(HyperPanel.ch.getGeneralBgColor());
        return ss;
    }

    protected static String hexColorValue(Color c) {
        String r = Integer.toHexString(c.getRed());
        String g = Integer.toHexString(c.getGreen());
        String b = Integer.toHexString(c.getBlue());
        return ("#" + r + g + b);
    }
}
