/*
 * $COPYRIGHT$
 * $Id: HyperPanel.java,v 1.110 2002/06/04 18:16:40 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.awt.event.KeyEvent;
import javax.swing.KeyStroke;
import java.awt.event.InputEvent;
import java.io.File;
import java.io.IOException;
import java.io.FileWriter;
import java.net.URL;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Dimension;
import java.awt.Component;
import java.awt.GridLayout;
import java.awt.FlowLayout;
import java.awt.BorderLayout;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.MouseListener;
import java.awt.event.ActionListener;
import java.util.Vector;
import java.util.Hashtable;
import java.util.StringTokenizer;
import javax.swing.ImageIcon;
import javax.swing.Box;
import javax.swing.Action;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JApplet;
import javax.swing.JToolBar;
import javax.swing.JMenuBar;
import javax.swing.BoxLayout;
import javax.swing.UIManager;
import javax.swing.JComponent;
import javax.swing.JPopupMenu;
import javax.swing.JOptionPane;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.ButtonGroup;
import javax.swing.LookAndFeel;
import javax.swing.JFileChooser;
import javax.swing.BorderFactory;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;
import javax.swing.SwingConstants;
import javax.swing.AbstractButton;
import javax.swing.text.TextAction;
import javax.swing.text.StyledDocument;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.Element;
import javax.swing.text.Position;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.text.html.StyleSheet;
import javax.swing.UnsupportedLookAndFeelException;
import org.media.hyperpad.conf.*;
import org.media.mn8.*;
import org.media.naming.*;
import org.media.mn8.concepts.SeriesConcept;
import org.media.hyperpad.gui.*;
import com.l2fprod.gui.plaf.skin.Skin; 
import com.l2fprod.gui.plaf.skin.CompoundSkin; 
import com.l2fprod.gui.plaf.skin.SkinLookAndFeel;
/**
 * Class meant to construct the GUI intreface for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.110 $ $Date: 2002/06/04 18:16:40 $
 * @see String
 */        
public class HyperPanel extends JApplet {
    static String XMLpath;
    public static ConfCache confcache;
    static JToolBar jNavigationBar, jToolBar; 
    JPanel NorthPanel;
    static HypButton largeicon, smallicon, runButton, stopButton, resetButton;
    static HypButton saveButton, undoButton, redoButton, sourceUndoButton, sourceRedoButton;
    static HypMenuItem saveMenu, undoMenu, redoMenu, runMenu, stopMenu, runSel, browse;
    static HypLabel jLabel;
    static JProgressBar prgBar;
    static HypTextPane pane, editorpane;
    static JScrollPane iactivmode, sourceeditor;
    static HypTabbedPane jTabPane;
    JPopupMenu pmenu;
    HypComboBox jCombo;
    static HypMenu openRecent;
    protected static JMenuBar MenuBar;
    static javax.swing.DefaultComboBoxModel cbModel;
    static JDialog aboutBox;
    static JFrame frame;
    String lookAndFeel;
    static ConfigHandler ch;
    static ComboHandler cbh;
    static OpenRecentListHandler orlh;
    static BookmarksHandler bmh;
    static ComponentManager cm;
    private Action[] defaultActions = {};
    Hashtable commands;
    static HyperEditorKit hek, shek;
    StringTokenizer st;
    static UndoHandler uh;
    protected static String _iactivDocPath = "Unknown";
    protected static String _sourceDocPath = "Unknown";
    protected static boolean iactivDocSaved = true;
    protected static boolean sourceDocSaved = true;
    boolean linkStatus = false;
    boolean defaultLookAndFeel = false;
    boolean updated = false;
    protected static int documentLength = 0;
    protected static int sourceDocumentLength = 0;
    protected static mn8ThreadedRun mn8Run;
    static int[] guidePositions = new int[2];
    
    public HyperPanel() {
        try {
            Class _this = Class.forName("org.media.hyperpad.HyperPanel");
            String urlpath = _this.getResource("/conf/hyperpad.xml").toString();
            XMLpath = urlpath.substring(5, urlpath.length());
        } catch (Exception exp) {}
        confcache = new ConfCache();
        ch = new ConfigHandler(XMLpath);
        applyLookAndFeel(ch.getLookAndFeel());
        cm = new ComponentManager();
        cbh = new ComboHandler();
        orlh = new OpenRecentListHandler();
        bmh = new BookmarksHandler();
        jNavigationBar = new JToolBar();
        jToolBar = new JToolBar();
        pmenu = new JPopupMenu();
        pane = new HypTextPane(HypTextPane.LINE_WRAP);
        pane.setBackground(ch.getGeneralBgColor());
        hek = new HyperEditorKit(0);
        pane.setEditorKit(hek);
        HyperDocument hdoc = (HyperDocument)pane.getDocument();
        hdoc.insertPrompt();
        pane.addMouseListener(new java.awt.event.MouseAdapter() {
            URL url;
            final javax.swing.Timer timer = new javax.swing.Timer(300, new ActionListener() {
                public void actionPerformed(ActionEvent ae) {
                    timer.stop();
                    if (url != null) {
                        activateLink(url, true);
                    }
                }
            });
            public void mouseClicked(MouseEvent me) {
                if (SwingUtilities.isLeftMouseButton(me)) {
                    int clickPosition = pane.viewToModel(new java.awt.Point(me.getX(), me.getY()));
                    URL currentURL = getLinkURL(clickPosition, pane);
                    if (timer.isRunning() && currentURL != null && url.equals(currentURL)) {
                        timer.stop();
                        activateLink(url, false);
                    }
                    else {
                        timer.restart();
                        url = currentURL;
                    }
                }
                else if (SwingUtilities.isRightMouseButton(me)) {
                    if (pane.getSelectedText() != null &&
                        pane.getSelectedText().length() != 0) {
                        runSel.setEnabled(true);
                        browse.setEnabled(true);
                    }
                    else {
                        runSel.setEnabled(false);
                        browse.setEnabled(false);
                    }
                    pmenu.show(pane, me.getX(), me.getY());
                    pmenu.pack();
                }
            }
        });
        pane.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(MouseEvent me) {
                URL url = getLinkURL(pane.viewToModel(new java.awt.Point(me.getX(), me.getY())), pane);
            }
        });
        pane.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent ce) {
                if (guidePositions[0] <= ce.getDot()) {
                    pane.getCaret().setVisible(true);
                    guidePositions[1] = ce.getDot();
                }
                else if (pane.getSelectedText() == null) {
                    pane.getCaret().setVisible(true);
                    pane.setCaretPosition(guidePositions[1]);
                }
                else {
                    pane.getCaret().setVisible(false);
                }
            }
        });
        editorpane = new HypTextPane(HypTextPane.LINE_WRAP);
        editorpane.setBackground(ch.getGeneralBgColor());
        shek = new HyperEditorKit(1);
        editorpane.setEditorKit(shek);
        editorpane.addMouseListener(new java.awt.event.MouseAdapter() {
            URL url;
            final javax.swing.Timer timer = new javax.swing.Timer(300, new ActionListener() {
                public void actionPerformed(ActionEvent ae) {
                    timer.stop();
                    if (url != null) {
                        activateLink(url, true);
                    }
                }
            });
            public void mouseClicked(MouseEvent me) {
                if (SwingUtilities.isLeftMouseButton(me)) {
                    int clickPosition = editorpane.viewToModel(new java.awt.Point(me.getX(), me.getY()));
                    URL currentURL = getLinkURL(clickPosition, editorpane) ;
                    if (timer.isRunning() && currentURL != null && url.equals(currentURL)) {
                        timer.stop();
                        activateLink(url, false);
                    }
                    else {
                        timer.restart();
                        url = currentURL;
                    }
                }
                else if (SwingUtilities.isRightMouseButton(me)) {
                    if (editorpane.getSelectedText() != null &&
                        editorpane.getSelectedText().length() != 0) {
                        runSel.setEnabled(true);
                        browse.setEnabled(true);
                    }
                    else {
                        runSel.setEnabled(false);
                        browse.setEnabled(false);
                    }
                    pmenu.show(editorpane, me.getX(), me.getY());
                    pmenu.pack();
                }
            }
        });
        editorpane.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(MouseEvent me) {
               URL url = getLinkURL(editorpane.viewToModel(new java.awt.Point(me.getX(), me.getY())), editorpane);
            }
        });
        HyperActivKeyListener hak = new HyperActivKeyListener(pane);
        HyperSourceKeyListener hsk = new HyperSourceKeyListener(editorpane);
        uh = new UndoHandler();
        pane.getDocument().addUndoableEditListener(uh);
        editorpane.getDocument().addUndoableEditListener(uh);
        iactivmode = new JScrollPane(pane);
        sourceeditor = new JScrollPane(editorpane);
        jTabPane = new HypTabbedPane(HypTabbedPane.BOTTOM);
        commands = new Hashtable();
        Action[] actions = getActions();
        for (int i = 0; i < actions.length; i++) {
            Action a = actions[i];
            commands.put(a.getValue(Action.NAME), a);
        }
        st = new StringTokenizer(file+" "+edit);
    }

    public void init() {
        try {
            makePopupMenu();
            panelInit();
            mn8Interpreter.initialize();
        }
        catch(Exception ex) {}
    }
    
    private void panelInit() throws Exception {
        jLabel = new HypLabel();
        jLabel.setFont(ch.getMenuFont());
        jLabel.setText("Ready");
        jLabel.setBorder(BorderFactory.createLineBorder(java.awt.Color.gray, 2));
        prgBar = new JProgressBar();
        prgBar.setStringPainted(true);
        JPanel cpanel = new JPanel();
        cpanel.setLayout(new BoxLayout(cpanel, BoxLayout.X_AXIS));
        jCombo = inicializeComboBox();
        jCombo.setEditable(true);
        jCombo.setEditor(new NavigatorBoxEditor());
        cpanel.setAlignmentY(CENTER_ALIGNMENT);
        cpanel.add(Box.createRigidArea(new Dimension(10,1)));
        cpanel.add(jCombo);
        cpanel.add(Box.createRigidArea(new Dimension(10,1)));
        
        largeicon = new HypButton(MyResources.getImageIcon("staticlargeicon"));
        largeicon.setBorderPainted(false);
        largeicon.setRequestFocusEnabled(false);
        largeicon.setMargin(new Insets(0,0,0,0));
        smallicon = new HypButton(MyResources.getImageIcon("staticsmallicon"));
        smallicon.setBorderPainted(false);
        smallicon.setRequestFocusEnabled(false);
        smallicon.setMargin(new Insets(0,0,0,0));
        
        jTabPane.setFont(ch.getMenuFont());
        jTabPane.setRequestFocusEnabled(false);
        jTabPane.addTab(MyResources.getTextValue("tab_1"), iactivmode);
        jTabPane.addTab(MyResources.getTextValue("tab_2"), sourceeditor);
        jTabPane.addMouseMotionListener(new java.awt.event.MouseMotionListener() {
            public void mouseDragged(MouseEvent me) {}     
            public void mouseMoved(MouseEvent me) {
                int tabIndex = jTabPane.getUI().tabForCoordinate(jTabPane, me.getX(), me.getY());
                setTabForegroundAt(jTabPane, tabIndex);
            }
        });
        jTabPane.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(MouseEvent me) {
                if (jTabPane.getSelectedIndex() == 0) {
                    setTabIndex(jTabPane.getSelectedIndex());
                }
                else if (jTabPane.getSelectedIndex() == 1) {
                    setTabIndex(jTabPane.getSelectedIndex());
                }
            }
        });
        jNavigationBar.setLayout(new BorderLayout());
        jNavigationBar.setFloatable(false);
        jNavigationBar.add(createNavigationbar(), "West");
        jNavigationBar.add(cpanel, "Center");
        if (ch.getButtonDisplay().equals(textonly) || ch.getButtonDisplay().equals(iconsonly)) {
            jNavigationBar.add(smallicon, "East");
        }
        else {
            jNavigationBar.add(largeicon, "East");
        }
                                                                                                
        NorthPanel = new JPanel();
        NorthPanel.setLayout(new BoxLayout(NorthPanel, BoxLayout.Y_AXIS));
        NorthPanel.add(createToolbar());
        if (ch.getNavigationBarStatus()) {
            NorthPanel.add(jNavigationBar);
        }

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(NorthPanel, "North");
        getContentPane().add(jTabPane, "Center");
        getContentPane().add(jLabel, "South");

        if (ch.getProxyStatus()) {
            System.getProperties().put("proxySet", "true");
            System.getProperties().put("proxyHost", ch.getHttpProxyHost());
            System.getProperties().put("proxyPort", ch.getHttpProxyPort());
            System.getProperties().put("ftpProxySet", "true");
            System.getProperties().put("ftpProxyHost", ch.getFtpProxyHost());
            System.getProperties().put("ftpProxyPort", ch.getFtpProxyPort());
        }

        frame = getRootFrame(jTabPane);
        frame.addFocusListener(new java.awt.event.FocusListener() {
            public void focusGained(java.awt.event.FocusEvent fe) {
                pane.requestFocus();
                pane.setCaretPosition(pane.getDocument().getLength());
            }
            public void focusLost(java.awt.event.FocusEvent fe) {}
        });
        frame.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent ke) {
                if (ke.getKeyCode() == KeyEvent.VK_F5) {
                    changeTab();
                }
                else if (ke.getKeyCode() == KeyEvent.VK_F9) {
                    if (jTabPane.getSelectedIndex() == 0) {
                        if (pane.getSelectedText() != null &&
                            pane.getSelectedText().length() != 0) {
                            makeExecute(pane.getSelectedText());
                        }
                        else if (editorpane.getDocument().getLength() != 0) {
                            try {
                                makeExecute(editorpane.getDocument().getText(0, editorpane.getDocument().getLength()));
                            } catch (Exception ex) {}
                        }
                    }
                    else if (jTabPane.getSelectedIndex() == 1) {
                        if (editorpane.getSelectedText() != null &&
                            editorpane.getSelectedText().length() != 0) {
                            makeExecute(editorpane.getSelectedText());
                        }
                        else if (editorpane.getDocument().getLength() != 0) {
                            try {
                                makeExecute(editorpane.getDocument().getText(0, editorpane.getDocument().getLength()));
                            } catch (Exception ex) {}
                        }
                    }
                }
            }
        });
        setOutput();
    }
    
    protected JMenuBar createMenubar() {
        MenuBar = new JMenuBar();
        MenuBar.setFont(ch.getMenuFont());
        String[] menuKeys = tokenize(menubar);
        for (int i = 0; i < menuKeys.length; i++) {
            HypMenu m = createMenu(menuKeys[i]);
            if (m != null) {
                MenuBar.add(m);
                cm.addComponent(m);
            }
        }
        return MenuBar;
    }

    private HypMenu createMenu(String key) {
        String[] itemKeys = null;
        if (key.equals("file")) {
            itemKeys = tokenize(file);
        }
        else if (key.equals("edit")) {
            itemKeys = tokenize(edit);
        }
        else if (key.equals("view")) {
            itemKeys = tokenize(view);
        }
        else if (key.equals("bookmarks")) {
            return bmh.createBookmarksMenu();
        }
        else if (key.equals("help")) {
            itemKeys = tokenize(help);
        }
        HypMenu menu = new HypMenu(MyResources.getLabels(key + "Label"));
        char mnemonic = getResourceMnemonic(key + "Label");
        if (mnemonic != '!') {
            menu.setMnemonic(mnemonic);
        }
        menu.setFont(ch.getMenuFont());
        HypMenuItem mi = null;
        for (int i = 0; i < itemKeys.length; i++) {
            if (itemKeys[i].equals("-")) {
                menu.addSeparator();
            } 
            else if (itemKeys[i].startsWith("radio")) {
                HypRadioButtonMenuItem jrb = new 
                    HypRadioButtonMenuItem(getResourceString(itemKeys[i] + "Label"));
                jrb.setFont(ch.getMenuFont());
                menu.add(jrb);
                cm.addComponent(jrb);
            }
            else if (itemKeys[i].startsWith("check")) {
                final HypCheckBoxMenuItem jcb = new 
                    HypCheckBoxMenuItem(MyResources.getLabels(itemKeys[i] + "Label"));
                char mnem = getResourceMnemonic(key + "Label");
                if (mnem != '!') {
                    jcb.setMnemonic(mnem);
                }
                jcb.setFont(ch.getMenuFont());
                menu.add(jcb);
                cm.addComponent(jcb);
                if (itemKeys[i].equals("checkHTMLMode")) {
                    if (ch.getHTMLMode()) {
                        jcb.setSelected(true);
                    }
                    else if (!ch.getHTMLMode()) {
                        jcb.setSelected(false);
                    }
                    setShortcutKey("checkHTMLMode", jcb);
                    jcb.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            if (jcb.isSelected()) {
                                ch.setHTMLMode(true);
                                ch.save(XMLpath);
                            }
                            else if (!jcb.isSelected()) {
                                ch.setHTMLMode(false);
                                ch.save(XMLpath);
                            }
                        }
                    });
                }
                else if (itemKeys[i].equals("checkHighlight")) {
                    if (ch.getHighlight()) {
                        jcb.setSelected(true);
                    }
                    else if (!ch.getHighlight()) {
                        jcb.setSelected(false);
                    }
                    setShortcutKey("checkHighlight", jcb);
                    jcb.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            if (jcb.isSelected()) {
                                ch.setHighlight(true);
                                ch.save(XMLpath);
                                editorpane.select(0, editorpane.getDocument().getLength());
                                String buffer = editorpane.getSelectedText();
                                editorpane.replaceSelection(buffer);
                            }
                            else if (!jcb.isSelected()) {
                                ch.setHighlight(false);
                                ch.save(XMLpath);
                                editorpane.select(0, editorpane.getDocument().getLength());
                                String buffer = editorpane.getSelectedText();
                                editorpane.replaceSelection(buffer);
                            }
                        }
                    });
                }
                else if (itemKeys[i].equals("checkEditable")) {
                    jcb.setSelected(true);
                    jcb.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            if (jcb.isSelected()) {
                                pane.setEditable(true);
                            }
                            else if (!jcb.isSelected()) {
                                pane.setEditable(false);
                            }
                        }
                    });
                }
            }
            else if (itemKeys[i].startsWith("submenu")) {
                HypMenu jm = createSubMenu(itemKeys[i]);
                jm.setFont(ch.getMenuFont());
                menu.add(jm);
                cm.addComponent(jm);
                if (itemKeys[i].equals("submenuOpenRecent")) {
                    openRecent = jm;
                    menu.remove(jm);
                    menu.add(openRecent);
                }
            }
            else {
                mi = createMenuItem(itemKeys[i]);
                mi.setFont(ch.getMenuFont());
                menu.add(mi);
                cm.addComponent(mi);
            }
            if (itemKeys[i].equals("about")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if(aboutBox == null) {
                            AboutBox ab = new AboutBox(frame, XMLpath);
                            ab.setVisible(true);
                        }
                    }
                });        
            }
            else if (itemKeys[i].equals("new")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        newDocument();
                    }
                });        
            }
            else if (itemKeys[i].equals("open")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        OpeningThread oth = new OpeningThread(null, null);
                        oth.start();
                    }
                });        
            }
            else if (itemKeys[i].equals("save")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if (jTabPane.getSelectedComponent() == iactivmode && 
                            _iactivDocPath.startsWith("Unknown")) {
                            saveAsDocument();
                        }
                        else if (jTabPane.getSelectedComponent() == sourceeditor && 
                                 _sourceDocPath.startsWith("Unknown")) {
                            saveAsDocument();
                        }
                        else {
                            saveDocument();
                        }
                    }
                }); 
                saveMenu = mi;
                saveMenu.setEnabled(false);
            }
            else if (itemKeys[i].equals("saveAs")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        saveAsDocument();
                    }
                });        
            }
            else if (itemKeys[i].equals("exit")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        System.exit(0);
                    }
                });        
            }
            else if (itemKeys[i].equals("preferences")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        PreferencesBox pb = new PreferencesBox(frame);
                        pb.setVisible(true);
                    }
                });        
            }
            else if (itemKeys[i].equals("selectAll")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        pane.selectAll();
                    }
                });        
            }
            else if (itemKeys[i].equals("find")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if (jTabPane.getSelectedIndex() == 1) {
                            FindBox fb = new FindBox(frame, editorpane, 0);
                            fb.setVisible(true);
                        }                            
                        else if (jTabPane.getSelectedIndex() == 0) {
                            FindBox fb = new FindBox(frame, pane, 0);
                            fb.setVisible(true);
                        }
                    }
                });        
            }
            else if (itemKeys[i].equals("replace")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if (jTabPane.getSelectedIndex() == 1) {
                            FindBox fb = new FindBox(frame, editorpane, 1);
                            fb.setVisible(true);
                        }                            
                        else if (jTabPane.getSelectedIndex() == 0) {
                            FindBox fb = new FindBox(frame, pane, 1);
                            fb.setVisible(true);
                        }
                    }
                });        
            }
            else if (itemKeys[i].equals("goto")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        if (jTabPane.getSelectedIndex() == 1) {
                            FindBox fb = new FindBox(frame, editorpane, 2);
                            fb.setVisible(true);
                        }                            
                    }
                });        
            }
            else if (itemKeys[i].equals("help")) {
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        HelpBox hb = new HelpBox(frame);
                        hb.setVisible(true);
                    }
                });        
            }
        }
        return menu;
    }

    private HypMenuItem createMenuItem(String key) {
        HypMenuItem mi = new HypMenuItem(MyResources.getLabels(key + "Label"));
        char mnemonic = getResourceMnemonic(key + "Label");
        if (mnemonic != '!') {
            mi.setMnemonic(mnemonic);
        }
        setShortcutKey(key, mi);
        if (key.equals("copy") || key.equals("cut") || key.equals("paste")) {
            Action a = getActionFor(key);
            if (a != null) {
                mi.setActionCommand(key);
                mi.addActionListener(a);
            }
            else {
                mi.setEnabled(false);
            }
        }
        else if (key.equals("undo")) {
            mi.setActionCommand(key);
            mi.addActionListener(new UndoAction(uh));
            undoMenu = mi;
            undoMenu.setEnabled(false);
        }
        else if (key.equals("redo")) {
            mi.setActionCommand(key);
            mi.addActionListener(new RedoAction(uh));
            redoMenu = mi;
            redoMenu.setEnabled(false);
        }                        
        return mi;
    }

    private HypMenu createSubMenu(String key) {
        if (key.equals("submenuLF")) {
            HypMenu menu = new HypMenu(getResourceString("submenuLFLabel"));
            ButtonGroup bg = new ButtonGroup();
            HypRadioButtonMenuItem jrb;
            final UIManager.LookAndFeelInfo installed[] = UIManager.getInstalledLookAndFeels();
            for (int i = 0; i < installed.length; i++) {
                final String name = installed[i].getName();
                final String classname = installed[i].getClassName();
                jrb = new HypRadioButtonMenuItem(name);
                jrb.setFont(ch.getMenuFont());
                menu.add(jrb);
                bg.add(jrb);
                cm.addComponent(jrb);
                addAction(jrb, name, classname);
                if (name.toLowerCase().equals(ch.getLookAndFeel().toLowerCase()) ||
                    (name.toLowerCase().equals("metal") && defaultLookAndFeel)) {
                    jrb.setSelected(true);
                }
            }
            if (new File("lib/skins/").exists()) {
                File skins = new File("lib/skins/");
                File[] files = skins.listFiles();
                String menuName;
                for (int i = 0; i < files.length; i++) {
                    String fileName = ((File)files[i]).getName();
                    if (((File)files[i]).isFile() && fileName.endsWith(".zip")) {
                        if (fileName.lastIndexOf("-") != -1) { 
                            menuName = fileName.substring(0, fileName.lastIndexOf("-"));
                        }
                        else {
                            menuName = fileName.substring(0, fileName.lastIndexOf(".zip"));
                        }
                        HypRadioButtonMenuItem jrbmi = new HypRadioButtonMenuItem(menuName);
                        jrbmi.setFont(ch.getMenuFont());
                        menu.add(jrbmi);
                        bg.add(jrbmi);
                        addAction(jrbmi, menuName, "com.l2fprod.gui.plaf.skin.SkinLookAndFeel");
                        if (menuName.toLowerCase().equals(ch.getLookAndFeel().toLowerCase()) && 
                                !defaultLookAndFeel) {
                            jrbmi.setSelected(true);
                        }
                    }
                }
            }
            return menu;
        }
        else if (key.equals("submenuNavBar")) {
            HypMenu menu = new HypMenu(getResourceString("submenuNavBarLabel"));
            ButtonGroup bg = new ButtonGroup();
            String[] submenuItems = tokenize(NavBarSubMenuItems);
            for (int i = 0; i < submenuItems.length; i++) {
                if (submenuItems[i].equals("-")) {
                    menu.addSeparator();
                } 
                else if (submenuItems[i].startsWith("radio")) {
                    HypRadioButtonMenuItem jrb = new 
                        HypRadioButtonMenuItem(getResourceString(submenuItems[i] + "Label"));
                    jrb.setFont(ch.getMenuFont());
                    menu.add(jrb);
                    bg.add(jrb);
                    cm.addComponent(jrb);
                    if (submenuItems[i].equals("radiotext")) {
                        if (ch.getButtonDisplay().equals(textonly)) {
                            jrb.setSelected(true);
                        }
                        jrb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                ch.setButtonDisplay(textonly);
                                ch.save(XMLpath);
                                cm.updateNavigationBarComponents();
                                jNavigationBar.remove(jNavigationBar.getComponentCount()-1);
                                jNavigationBar.add(smallicon, BorderLayout.EAST);
                                SwingUtilities.updateComponentTreeUI(frame);
                            }
                        });
                    }
                    else if (submenuItems[i].equals("radiotext&icons")) {
                        if (ch.getButtonDisplay().equals(textandicons)) {
                            jrb.setSelected(true);
                        }
                        jrb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                ch.setButtonDisplay(textandicons);
                                ch.save(XMLpath);
                                cm.updateNavigationBarComponents();
                                jNavigationBar.remove(jNavigationBar.getComponentCount()-1);
                                jNavigationBar.add(largeicon, BorderLayout.EAST);
                                SwingUtilities.updateComponentTreeUI(frame);
                            }
                        });
                    }
                    else if (submenuItems[i].equals("radioicons")) {
                        if (ch.getButtonDisplay().equals(iconsonly)) {
                            jrb.setSelected(true);
                        }
                        jrb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                ch.setButtonDisplay(iconsonly);
                                ch.save(XMLpath);
                                cm.updateNavigationBarComponents();
                                jNavigationBar.remove(jNavigationBar.getComponentCount()-1);
                                jNavigationBar.add(smallicon, BorderLayout.EAST);
                                SwingUtilities.updateComponentTreeUI(frame);
                            }
                        });
                    }
                }
                else if (submenuItems[i].startsWith("check")) {
                    final HypCheckBoxMenuItem jcb = new HypCheckBoxMenuItem(getResourceString(submenuItems[i] + "Label"));
                    jcb.setFont(ch.getMenuFont());
                    menu.add(jcb);
                    cm.addComponent(jcb);
                    if (submenuItems[i].equals("checkActive")) {
                        if (ch.getNavigationBarStatus()) {
                            jcb.setSelected(true);
                        }
                        else if (!ch.getNavigationBarStatus()) {
                            jcb.setSelected(false);
                        }
                        jcb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                if (jcb.isSelected()) {
                                    NorthPanel.add(jNavigationBar);
                                    jToolBar.remove(jToolBar.getComponentCount()-1);
                                    if (ch.getButtonDisplay().equals(textonly) || ch.getButtonDisplay().equals(iconsonly)) {
                                        jNavigationBar.add(smallicon, BorderLayout.EAST);
                                    }
                                    SwingUtilities.updateComponentTreeUI(frame);
                                    ch.setNavigationBarStatus(true);
                                    ch.save(XMLpath);
                                }
                                else if (!jcb.isSelected()) {
                                    NorthPanel.remove(jNavigationBar);
                                    jToolBar.add(smallicon, BorderLayout.EAST);
                                    SwingUtilities.updateComponentTreeUI(frame);
                                    ch.setNavigationBarStatus(false);
                                    ch.save(XMLpath);
                                }
                            }
                        }); 
                    }
                }
            }
            return menu;
        }
        else if (key.equals("submenumn8")) {
            HypMenu menu = new HypMenu(getResourceString("submenumn8Label"));
            String[] submenuItems = tokenize(mn8SubMenuItems);
            for (int i = 0; i < submenuItems.length; i++) {
                if (submenuItems[i].startsWith("check")) {
                    final HypCheckBoxMenuItem jcb = new HypCheckBoxMenuItem(getResourceString(submenuItems[i] + "Label"));
                    jcb.setFont(ch.getMenuFont());
                    menu.add(jcb);
                    jcb.setSelected(false);
                    if (submenuItems[i].equals("checkVerbose")) {
                        jcb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                if (jcb.isSelected()) {
                                    mn8RuntimeFlags.setVerbose(true);
                                }
                                else {
                                    mn8RuntimeFlags.setVerbose(false);
                                }
                            }
                        });
                    }
                    if (submenuItems[i].equals("checkDebug")) {
                        jcb.addActionListener(new ActionListener() {
                            public void actionPerformed(ActionEvent e) {
                                if (jcb.isSelected()) {
                                    mn8RuntimeFlags.setDebug(true);
                                }
                                else {
                                    mn8RuntimeFlags.setDebug(false);
                                }
                            }
                        });
                    }
                }
            }
            return menu;
        }
        else if (key.equals("submenuOpenRecent")) {
            boolean empty = true;
            HypMenu menu = new HypMenu(getResourceString("submenuOpenRecentLabel"));
            for (int i = 0; i < 20; i++) {
                String item = orlh.getListItem(i);
                if (!item.equals("")) {
                    HypMenuItem mi = new HypMenuItem(item);
                    mi.setFont(ch.getMenuFont());
                    mi.addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            OpeningThread oth = new OpeningThread(((HypMenuItem)e.getSource()).getText(), null);
                            oth.start();
                        }
                    });
                    menu.add(mi);
                    empty = false;
                }
            }
            if (empty) {
                HypMenuItem mi = new HypMenuItem("(empty)");
                mi.setFont(ch.getMenuFont());
                mi.setEnabled(false);
                menu.add(mi);
            }
            return menu;
        }
        else {
            return null;
        }
    }

    protected static void updateOpenRecentMenu() {
        openRecent.removeAll();
        for (int i = 0; i < 20; i++) {
            if (!orlh.getListItem(i).equals("")) {
                HypMenuItem mi = new HypMenuItem(orlh.getListItem(i));
                mi.setFont(ch.getMenuFont());
                mi.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        OpeningThread oth = new OpeningThread(((HypMenuItem)e.getSource()).getText(), null);
                        oth.start();
                    }
                });
                openRecent.add(mi);
            }
        }
    }

    private void appendOpenRecentList(String newItem) {
        orlh.appendList(newItem);
        updateOpenRecentMenu();
    }

    private void applyLookAndFeel(String name) {
        boolean isInstalled = false;
        UIManager.LookAndFeelInfo installed[] = UIManager.getInstalledLookAndFeels();
        for (int i = 0; i < installed.length; i++) {
            String LFname = installed[i].getName();
            String LFclassname = installed[i].getClassName();
            if (name.toLowerCase().equals(LFname.toLowerCase())) {
                try {
                    UIManager.setLookAndFeel(LFclassname);
                    SwingUtilities.updateComponentTreeUI(this);
                    isInstalled = true;
                } catch (Exception ex) {
                    System.err.println("Can't use the look and feel you specified in hyperpad.xml.");
                }
            }
        }
        if (!isInstalled) {
            try {
                Skin skin = SkinLookAndFeel.loadThemePack("lib/skins/"+name+"-themepack.zip");
                SkinLookAndFeel.setSkin(skin);
                UIManager.setLookAndFeel("com.l2fprod.gui.plaf.skin.SkinLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this);
            } catch (Throwable th) {
                System.err.println("Can't use the look and feel you specified in hyperpad.xml. Loading default...");
                ch.setLookAndFeel("Metal");
                ch.save(XMLpath);
                defaultLookAndFeel = true;
                applyLookAndFeel("Metal");
            }
        }
    }
    
    private void addAction(AbstractButton ab, final String key, final String lookAndFeel) {
        ab.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    int cursorPosition = pane.getCaretPosition();
                    if (lookAndFeel.equals("com.l2fprod.gui.plaf.skin.SkinLookAndFeel")) {
                        Skin skin = SkinLookAndFeel.loadThemePack("lib/skins/"+key+"-themepack.zip");
                        SkinLookAndFeel.setSkin(skin);
                    }
                    UIManager.setLookAndFeel(lookAndFeel);
                    SwingUtilities.updateComponentTreeUI(frame);
                    jLabel.setText(key + " look and feel set.");
                    ch.setLookAndFeel(key);
                    ch.save(XMLpath);
                    pane.setCaretPosition(cursorPosition);
                } catch (Throwable th) {
                    jLabel.setText("Can't use the specified look and feel.");
                }
            }
        });
    }

    protected static String[] tokenize(String input) {
        Vector v = new Vector();
        StringTokenizer t = new StringTokenizer(input);
        String keys[];
        
        while (t.hasMoreTokens())
	    v.addElement(t.nextToken());
        keys = new String[v.size()];
        for (int i = 0; i < keys.length; i++) {
            keys[i] = (String) v.elementAt(i);
        }
        return keys;
    }

    private Component createToolbar() {
        jToolBar.setLayout(new BorderLayout());
        jToolBar.setFloatable(false);
        JPanel buttonsPanel = new JPanel();
        String[] toolKeys = tokenize(toolbar);
        for (int i = 0; i < toolKeys.length; i++) {
            if (toolKeys[i].equals("-")) {
                buttonsPanel.add(Box.createHorizontalStrut(5));
            } else {
                buttonsPanel.add(createToolbarButton(toolKeys[i]));
            }
        }
        buttonsPanel.add(Box.createHorizontalGlue());
        jToolBar.add(buttonsPanel, BorderLayout.WEST);
        if (!ch.getNavigationBarStatus()) {
            jToolBar.add(smallicon, BorderLayout.EAST);
        }
        return jToolBar;
    }

    protected static void running(boolean value) {
        runButton.setEnabled(!value);
        runMenu.setEnabled(!value);
        stopButton.setEnabled(value);
        stopMenu.setEnabled(value);
    }

    private HypButton createToolbarButton(String key) {
        HypButton b = new HypButton(MyResources.getImageIcon(key + "Image")) {
            public float getAlignmentY() { return 0.5f; }
        };
        b.setRequestFocusEnabled(false);
        b.setMargin(new Insets(1,1,1,1));
        b.setFont(ch.getMenuFont());
        cm.addComponent(b);
        String tip = getResourceString(key + "Tooltip");
        if (tip != null) {
            b.setToolTipText(tip);
        }
        if (key.equals("run")) {
            runButton = b;
            runButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    try {
                        String script = editorpane.getDocument().getText(0, editorpane.getDocument().getLength());
                        if (script.trim().length() != 0) {
                            makeExecute(script);
                            running(true);
                        }
                    } catch (Exception ex) {}
                }
            });
        }
        else if (key.equals("stop")) {
            stopButton = b;
            stopButton.setEnabled(false);
            stopButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    try {
                        mn8Run.kill();
                    } catch (Exception ex) {}
                }
            });
        }
        if (key.equals("new")) {
            b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    newDocument();
                }
            });        
        }
        else if (key.equals("open")) {
            b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    OpeningThread oth = new OpeningThread(null, null);
                    oth.start();
                }
            });        
        }
        else if (key.equals("copy") || key.equals("cut") || key.equals("paste")) {
            Action a = getActionFor(key);
            if (a != null) {
                b.setActionCommand(key);
                b.addActionListener(a);
            }
            else {
                b.setEnabled(false);
            }
        }
        else if (key.equals("undo")) {
            b.setActionCommand(key);
            b.addActionListener(new UndoAction(uh));
            undoButton = b;
            undoButton.setEnabled(false);
        }
        else if (key.equals("redo")) {
            b.setActionCommand(key);
            b.addActionListener(new RedoAction(uh));
            redoButton = b;
            redoButton.setEnabled(false);
        }
        else if (key.equals("save")) {
            b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    if (jTabPane.getSelectedComponent() == iactivmode && _iactivDocPath.startsWith("Unknown")) {
                        saveAsDocument();
                    }
                    else if (jTabPane.getSelectedComponent() == sourceeditor && _sourceDocPath.startsWith("Unknown")) {
                        saveAsDocument();
                    }
                    else {
                        saveDocument();
                    }
                }
            });
            saveButton = b;
            saveButton.setEnabled(false);
        }
        else if (key.equals("init")) {
            b.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    mn8Interpreter.reInitialize();
                }
            });
        }
        return b;
    }

    private JPanel createNavigationbar() {
        String[] navKeys = tokenize(navigationbar);
        JPanel navigationbar = new JPanel(new GridLayout(1,4));
        for (int i = 0; i < navKeys.length; i++) {
            navigationbar.add(createNavigationbarButton(navKeys[i]));
        }
        return navigationbar;
    }

    private HypButton createNavigationbarButton(String key) {
        if (ch.getButtonDisplay().equals(textonly)) {
            final HypButton b = new HypButton(MyResources.getLabels(key + "Label"));
            setNavigationButton(b, key);
            return b;
        }
        else if (ch.getButtonDisplay().equals(textandicons)) {
            final HypButton b = new HypButton(MyResources.getLabels(key + "Label"),
                                          MyResources.getImageIcon(key + "Image"));
            setNavigationButton(b, key);
            return b;
        }
        else if (ch.getButtonDisplay().equals(iconsonly)) {
            final HypButton b = new HypButton(MyResources.getImageIcon(key + "Image")); 
            setNavigationButton(b, key);
            return b;
        }
        else {
            return null;
        }
    }

    private void setNavigationButton(final HypButton b, final String key) {
        b.setRequestFocusEnabled(false);
        b.setBorderPainted(false);
        b.setMargin(new Insets(-1,-1,-1,-1));
        b.setVerticalTextPosition(SwingConstants.BOTTOM);
        b.setHorizontalTextPosition(SwingConstants.CENTER);
        b.setFont(ch.getMenuFont());
        cm.addComponent(b);
        cm.addNavigationBarComponent(b);
        b.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(MouseEvent me) {
                b.setBorderPainted(false);
                if (!ch.getButtonDisplay().equals(textonly)) {
                    b.setIcon(MyResources.getImageIcon(key + "OverImage"));
                }
            }
            public void mouseExited(MouseEvent me) {
                b.setBorderPainted(false);
                if (!ch.getButtonDisplay().equals(textonly)) {
                    b.setIcon(MyResources.getImageIcon(key + "Image"));
                }
            }
            public void mouseClicked(MouseEvent me) {
                if (key.equals("forw")) {
                    int pos = cbModel.getIndexOf(jCombo.getEditor().getItem());
                    if (pos-1 >= 0) {
                        String current = (String)cbModel.getElementAt(pos-1);
                        updated = true;
                        cbModel.setSelectedItem(current);
                        jCombo.getEditor().setItem(current);
                        pane.requestFocus();
                        OpeningThread oth = new OpeningThread(null, current);
                        oth.run();
                    }
                }
                else if (key.equals("back")) {
                    int pos = cbModel.getIndexOf(jCombo.getEditor().getItem());
                    if (pos+1 < cbModel.getSize()) {
                        String current = (String)cbModel.getElementAt(pos+1);
                        updated = true;
                        if (pos+1 == 0) {
                            jCombo.getEditor().setItem(current);
                        }
                        jCombo.getEditor().setItem(current);
                        cbModel.setSelectedItem(current);
                        pane.requestFocus();
                        OpeningThread oth = new OpeningThread(null, current);
                        oth.run();
                    }
                }
                else if (key.equals("reload")) {
                    String current = (String)jCombo.getEditor().getItem();
                    updated = true;
                    cbModel.setSelectedItem(current);
                    pane.requestFocus();
                    if (!current.equals("")) {
                         OpeningThread oth = new OpeningThread(null, current);
                         oth.run();
                    }
                }
            }
        });
    }

    private void makePopupMenu() {
        HypMenuItem changeView = createMenuItem("changeView");
        changeView.setFont(ch.getMenuFont());
        changeView.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F5, 0));
        changeView.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                changeTab();
            }
        });
        browse = createMenuItem("browse");
        browse.setFont(ch.getMenuFont());
        browse.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (jTabPane.getSelectedIndex() == 0 && 
                    pane.getSelectedText() != null && 
                    pane.getSelectedText().length() != 0) {
                    try {
                        URL url = new URL(pane.getSelectedText());
                        activateLink(url, false);
                    } catch (Exception ex) {
                        HyperOptionPane.showDialog(frame, 
                                                   getResourceString("notValidURLWindowTitle"),
                                                   getResourceString("notValidURLMessage"),
                                                   HyperOptionPane.DEFAULT_OPTION);
                    }
                }
                else if (jTabPane.getSelectedIndex() == 1 && 
                         editorpane.getSelectedText() != null && 
                         editorpane.getSelectedText().length() != 0) {
                    try {
                        URL url = new URL(editorpane.getSelectedText());
                        activateLink(url, false);
                    } catch (Exception ex) {
                        HyperOptionPane.showDialog(frame, 
                                                   getResourceString("notValidURLWindowTitle"),
                                                   getResourceString("notValidURLMessage"),
                                                   HyperOptionPane.DEFAULT_OPTION);
                    }
                }
            }
        });
        runMenu = createMenuItem("run");
        runMenu.setFont(ch.getMenuFont());
        runMenu.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));
        runMenu.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    String script = editorpane.getDocument().getText(0, editorpane.getDocument().getLength());
                    if (script.trim().length() != 0) {
                        running(true);
                        jTabPane.setSelectedIndex(0);
                        makeExecute(script);
                    }
                } catch (Exception ex) {}
            }
        });
        stopMenu = createMenuItem("stop");
        stopMenu.setFont(ch.getMenuFont());
        stopMenu.setEnabled(false);
        stopMenu.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    mn8Run.kill();
                } catch (Exception ex) {}
            }
        });
        runSel = createMenuItem("runSelect");
        runSel.setFont(ch.getMenuFont());
        runSel.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));
        runSel.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (jTabPane.getSelectedIndex() == 0) {
                    if (pane.getSelectedText() != null && pane.getSelectedText().length() != 0) {
                        makeExecute(pane.getSelectedText());
                    }
                }
                else if (jTabPane.getSelectedIndex() == 1) {
                    if (editorpane.getSelectedText() != null && editorpane.getSelectedText().length() != 0) {
                        makeExecute(editorpane.getSelectedText());
                    }
                }
            }
        });
        HypMenuItem reinit = createMenuItem("reinit");
        reinit.setFont(ch.getMenuFont());
        reinit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                mn8Interpreter.reInitialize();
            }
        });
        HypMenuItem copy = createMenuItem("copy");
        copy.setFont(ch.getMenuFont());
        HypMenuItem paste = createMenuItem("paste");
        paste.setFont(ch.getMenuFont());
        HypMenuItem cut = createMenuItem("cut");
        cut.setFont(ch.getMenuFont());
        pmenu.add(changeView);
        pmenu.add(browse);
        pmenu.addSeparator();
        pmenu.add(runSel);
        pmenu.add(runMenu);
        pmenu.add(stopMenu);
        pmenu.addSeparator();
        pmenu.add(reinit);
        pmenu.addSeparator();
        pmenu.add(copy);
        pmenu.add(paste);
        pmenu.add(cut);
    }

    private void changeTab() {
        if (jTabPane.getSelectedIndex() == 0) {
            jTabPane.setSelectedIndex(1);
            setTabIndex(jTabPane.getSelectedIndex());
        }
        else if (jTabPane.getSelectedIndex() == 1) {
            jTabPane.setSelectedIndex(0);
            setTabIndex(jTabPane.getSelectedIndex());
        }
    }
    
    private HypComboBox inicializeComboBox() {
        Vector itemList = new Vector(navComboListLength);
        for (int i = 0; i < navComboListLength; i++) {
            if (!cbh.getListItem(i).equals("")) {
                itemList.add(cbh.getListItem(i));
            }
        }
        final HypComboBox jcb = new HypComboBox();
        cbModel = new javax.swing.DefaultComboBoxModel(itemList);
        jcb.setModel(cbModel);
        jcb.setFont(ch.getMenuFont());
        jcb.setForeground(java.awt.Color.black);
        jcb.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(ActionEvent ae) {
                if (!updated) {
                    updated = true;
                    cbModel.setSelectedItem(cbModel.getElementAt(0));
                    jCombo.getEditor().setItem(cbModel.getElementAt(0));
                    pane.requestFocus();
                }
                updated = false;
            }
        });
        jcb.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent ie) {
                if (ie.getStateChange() == java.awt.event.ItemEvent.SELECTED && jCombo.isPopupVisible() && !updated) {
                    updated = true;
                    updateComboList(ie.getItem().toString());
                }
            }
        });
        return jcb;
    }

    protected static void updateComboList(String current) {
        if (cbModel.getIndexOf(current) != -1) {
            cbModel.removeElement(current);
        }
        if (cbModel.getSize()+1 > navComboListLength) {
            cbModel.removeElementAt(cbModel.getSize()-1);
        }
        cbModel.insertElementAt(current, 0);
        OpeningThread oth = new OpeningThread(null, current);
        oth.run();
        sourceDocSaved = false;
        updateComboListXML();
    }

    protected static void updateComboListXML() {
        for (int i = 0; i < cbModel.getSize(); i++) {
            cbh.setListItem(i, cbModel.getElementAt(i).toString());
        }
        cbh.save();
    }

    private Action[] getActions() {
        return TextAction.augmentList(pane.getActions(), defaultActions);
    }

    private Action getAction(String cmd) {
        return (Action) commands.get(cmd);
    }

    protected static String getResourceString(String nm) {
        String str = MyResources.getTextValue(nm);
        return str;
    }

    protected static char getResourceMnemonic(String nm) {
        char mnemonic = MyResources.getMnemonic(nm);
        return Character.toUpperCase(mnemonic);
    }

    private char getResourceShortcut(String nm) {
        char shortcut = MyResources.getShortcut(nm);
        return Character.toUpperCase(shortcut);
    }

    private String getResourceModifiers(String nm) {
        String modifiers = MyResources.getModifiers(nm);
        return modifiers;
    }

    private String[] getShortcutKeyAndModifiers(String key) {
        String[] result = new String[2];
        char shortcutKey = '!';
        String modifiers = "";
        if (!ch.getShortcut(key).equals("!") && !ch.getShortcut(key).equals("+&+")) {
            String shortcutKeyAndModifier = ch.getShortcut(key);
            int separator = shortcutKeyAndModifier.indexOf("+&+");
            shortcutKey = Character.toUpperCase(shortcutKeyAndModifier.substring(0, separator).charAt(0));
            modifiers = shortcutKeyAndModifier.substring(separator+3, shortcutKeyAndModifier.length());
        }
        else if (getResourceShortcut(key + "Label") != '!' && !getResourceModifiers(key + "Label").equals("")) {
            shortcutKey = getResourceShortcut(key + "Label");
            modifiers = getResourceModifiers(key + "Label");
        }
        result[0] = new Character(shortcutKey).toString();
        result[1] = modifiers;
        return result;
    }

    private void setShortcutKey(String key, JComponent comp) {
        if (comp instanceof javax.swing.JMenuItem) {
            javax.swing.JMenuItem mi = (javax.swing.JMenuItem)comp;
            String[] SCKeyAndModifiers = getShortcutKeyAndModifiers(key);
            if (!key.equals("-") && !SCKeyAndModifiers[0].equals("!") && !SCKeyAndModifiers[1].equals("")) {
                char SCkey = SCKeyAndModifiers[0].charAt(0);
                String modifiers = SCKeyAndModifiers[1];
                if (modifiers.toUpperCase().equals("CTRL")) {
                    mi.setAccelerator(KeyStroke.getKeyStroke(SCkey, InputEvent.CTRL_MASK));
                }
                else if (modifiers.toUpperCase().equals("ALT")) {
                    mi.setAccelerator(KeyStroke.getKeyStroke(SCkey, InputEvent.ALT_MASK));
                }
                else if (modifiers.toUpperCase().equals("CTRL+ALT") || modifiers.toUpperCase().equals("ALT+CTRL")) {
                    mi.setAccelerator(KeyStroke.getKeyStroke(SCkey, InputEvent.CTRL_MASK|InputEvent.ALT_MASK));
                }
            }
        }
    }

    private JFrame getRootFrame(Component c) {
        if (c instanceof JFrame) {
            return (JFrame)c;
        }
        return getRootFrame(c.getParent()); 
    } 

    private void newDocument() {
        if (!iactivDocSaved || !sourceDocSaved) {
            int choice = HyperOptionPane.showDialog(frame, 
                                                    getResourceString("wantToSaveWindowTitle"),
                                                    getResourceString("wantToSaveMessage"),
                                                    HyperOptionPane.YES_NO_OPTION);
            if (choice == HyperOptionPane.YES) {
                if (jTabPane.getSelectedComponent() == iactivmode && _iactivDocPath.equals("Unknown")) {
                    saveAsDocument();
                }
                else if (jTabPane.getSelectedComponent() == sourceeditor && _sourceDocPath.equals("Unknown")) {
                    saveAsDocument();
                }
                else {
                    saveDocument();
                }
            }
        }
        if (jTabPane.getSelectedComponent() == iactivmode) {
            guidePositions[0] = 0;
            guidePositions[1] = 0;
            HyperDocument.bracketsNR = 0;
            pane.setEditorKit(hek);
            try {
                HyperDocument newdoc = (HyperDocument)pane.getDocument();
                newdoc.addUndoableEditListener(uh);
                newdoc.insertPrompt();
                setOutput();
                iactivDocSaved = true;
                _iactivDocPath = "Unknown";
                updateSaveButton();
            } catch (Exception ex) {}
        }
        else if (jTabPane.getSelectedComponent() == sourceeditor) {
            editorpane.setEditorKit(shek);
            editorpane.getDocument().addUndoableEditListener(uh);
            uh.sourceUndo.discardAllEdits();
            uh.updateUndo();
            uh.updateRedo();
            sourceDocSaved = true;
            _sourceDocPath = "Unknown";
            updateSaveButton();
            mn8Interpreter.reInitialize();
        }
    }
    
    private void saveDocument() {
        if (jTabPane.getSelectedComponent() == iactivmode) {
            makeSave(_iactivDocPath, true);
        }
        else if (jTabPane.getSelectedComponent() == sourceeditor) {
            makeSave(_sourceDocPath, true);
        }
    }

    private void saveAsDocument() {
        if (jTabPane.getSelectedComponent() == iactivmode) {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileFilter(new TXTFilter());
            chooser.addChoosableFileFilter(new HTMLFilter());
            chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
            int returnVal = chooser.showSaveDialog(frame);
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                makeSave(chooser.getSelectedFile().getPath(), false);
            }
        }
        else if (jTabPane.getSelectedComponent() == sourceeditor) {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileFilter(new MN8Filter());
            chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
            int returnVal = chooser.showSaveDialog(frame);
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                makeSave(chooser.getSelectedFile().getPath(), false);
            }
        }
    }

    private void makeSave(String path, boolean overwrite) {
        if (getExtension(path.trim()).toLowerCase().equals(TXTFile) || 
            getExtension(path.trim()).toLowerCase().equals(MN8File)) {
            save(path, getExtension(path.trim()), overwrite);
        }
        else if (!getExtension(path.trim()).equals("") && 
                 HTMLFile.lastIndexOf(getExtension(path.trim()).toLowerCase()) != -1) {
            save(path, getExtension(path.trim()), overwrite);
        }
        else {
            String type = selectType();
            if (null != type) {
                if (type.toLowerCase().equals("txt")) {
                    save(path, type, overwrite);
                }
                else if (type.toLowerCase().equals("html")) {
                    save(path, type, overwrite);
                }
            }
        }
    }

    private String selectType() {
        Vector elements = new Vector();
        elements.add("Txt");
        elements.add("HTML");
        return HyperOptionPane.showComboDialog(frame,
                                               getResourceString("selectTypeWindowTitle"),
                                               getResourceString("selectTypeMessage"),
                                               elements);
    }

    private String getExtension(String filename) {
        try {
            return filename.substring(filename.lastIndexOf(".")+1, filename.length());
        } catch (Exception ex) {
            return "";
        }
    }

    private void save(String path, String type, boolean overwrite) {
        try {
            if (new File(path).exists() && !overwrite) {
                if (HyperOptionPane.showDialog(frame, 
                                               getResourceString("fileExistsWindowTitle"),
                                               path + " " + getResourceString("fileExistsMessage"),
                                               HyperOptionPane.YES_NO_OPTION) == HyperOptionPane.NO) {
                    saveAsDocument();
                    return;
                }
            }
            FileWriter out = new FileWriter(path);
            if (type.toLowerCase().equals("txt") || type.toLowerCase().equals("mn8")) {
                javax.swing.text.DefaultEditorKit dek = new javax.swing.text.DefaultEditorKit();
                if (jTabPane.getSelectedComponent() == iactivmode) {
                    dek.write(out, pane.getDocument(), 0, pane.getDocument().getLength());
                    iactivDocSaved = true;
                    _iactivDocPath = path;
                }
                else if (jTabPane.getSelectedComponent() == sourceeditor) {
                    dek.write(out, editorpane.getDocument(), 0, editorpane.getDocument().getLength());
                    sourceDocSaved = true;
                    _sourceDocPath = path;
                    orlh.appendList(_sourceDocPath);
                    updateOpenRecentMenu();
                }
            }
            else if (type.toLowerCase().equals("html")) {
                if (jTabPane.getSelectedComponent() == iactivmode) {
                    hek.write(out, pane.getDocument(), 0, pane.getDocument().getLength());
                    iactivDocSaved = true;
                    _iactivDocPath = path;
                }
                else if (jTabPane.getSelectedComponent() == sourceeditor) {
                    hek.write(out, editorpane.getDocument(), 0, editorpane.getDocument().getLength());
                    sourceDocSaved = true;
                    _sourceDocPath = path;
                    orlh.appendList(_sourceDocPath);
                    updateOpenRecentMenu();
                }
            }
            out.close();
            updateSaveButton();
            jLabel.setText("File saved.");
        } catch (Exception ex) {
            HyperOptionPane.showDialog(frame, 
                                       getResourceString("saveErrorWindowTitle"),
                                       getResourceString("saveErrorMessage"),
                                       HyperOptionPane.DEFAULT_OPTION);
        }
    }

    private Action getActionFor(String key) {
        Action action = null;
        if (key.equals("copy")) {
            action = getAction("copy-to-clipboard");
        }
        else if (key.equals("paste")) {
            action = getAction("paste-from-clipboard");
        }
        else if (key.equals("cut")) {
            action = getAction("cut-to-clipboard");
        }
        else {
            action = null;
        }
        return action;
    }

    protected static void setTabForegroundAt(HypTabbedPane tabPane, int tabIndex) {
        if (tabIndex != -1) {
            tabPane.setForegroundAt(tabIndex, java.awt.Color.blue);
        }
        for(int i=0; i<tabPane.getTabCount(); i++) {
            if (tabIndex != i) {
                tabPane.setForegroundAt(i, java.awt.Color.black);
            }
        }
    }

    protected static void updateSaveButton() {
        if (jTabPane.getSelectedComponent() == iactivmode) {
            if (iactivDocSaved) {
                setSaveStatus(false);
            }
            else {
                setSaveStatus(true);
            }
        }
        else if (jTabPane.getSelectedComponent() == sourceeditor) {
            if (sourceDocSaved) {
                setSaveStatus(false);
            }
            else {
                setSaveStatus(true);
            }
        }
    }

    private static void setSaveStatus(boolean status) {
        saveButton.setEnabled(status);
        saveMenu.setEnabled(status);
    }

    private void setTabIndex(int index) {
        updateSaveButton();
        uh.updateUndo();
        uh.updateRedo();
    }

    private URL getLinkURL(int position, HypTextPane txtpane) {
        URL link = null;
        HTMLDocument hdoc = (HTMLDocument)txtpane.getDocument();
        try {
            Element elem = hdoc.getCharacterElement(position);
            javax.swing.text.AttributeSet attr = elem.getAttributes();
            javax.swing.text.AttributeSet anchor = 
                (javax.swing.text.AttributeSet) attr.getAttribute(javax.swing.text.html.HTML.Tag.A);
            if (anchor != null) {
                String href = (String)anchor.getAttribute(javax.swing.text.html.HTML.Attribute.HREF);
                if (href != null) {
                    pane.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
                    if (href.trim().length() != 0) {
                        jLabel.setText(href);
                    }
                    else {
                        jLabel.setText(" ");
                    }
                    link = new URL(href);
                }
                else {
                    pane.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                    jLabel.setText(" ");
                }
            }
            else {
                String all = hdoc.getText(0, hdoc.getLength());
                if (position != all.length()) {
                    String before = all.substring(0, position);
                    int spaceBefore = before.lastIndexOf(" ");
                    int eolBefore = before.lastIndexOf("\n");
                    int spaceAfter = all.indexOf(" ", position);
                    int eolAfter = all.indexOf("\n", position);
                    int start = 0;
                    int end = 0;
                    if (((spaceBefore == -1 && eolBefore != -1) || spaceBefore < eolBefore) && position > eolBefore+1) {
                        start = eolBefore + 1;
                    }
                    else if ((spaceBefore != -1 && eolBefore == -1) || spaceBefore > eolBefore) {
                        start = spaceBefore + 1;
                    }
                    if (spaceAfter == -1 && eolAfter == -1) {
                        end = all.length();
                    }
                    else if (eolAfter != -1 && (spaceAfter == -1 || spaceAfter > eolAfter)) {
                        end = eolAfter;
                    }
                    else if ((spaceAfter != -1 && eolAfter == -1) || spaceAfter < eolAfter) {
                        end = spaceAfter;
                    }
                    if (position != end) {
                        try {
                            String lnk = all.substring(start, end);
                            if (lnk.startsWith(prompt) && position >= start+prompt.length()) {
                                lnk = lnk.substring(prompt.length(), lnk.length());
                            }
                            if (lnk.indexOf("\n") == -1) {
                                URL url = new URL(lnk);
                                txtpane.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
                                link = url;
                                jLabel.setText(lnk);
                            }
                        } catch (Exception ex) {
                            txtpane.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                            jLabel.setText(" ");
                        }
                    }
                }
                else {
                    txtpane.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
                    jLabel.setText(" ");
                }
            }
        } catch (Exception ex) {}
        return link;
    }

    private void activateLink(URL url, boolean ask) {
        if (ask) {
            int choice = HyperOptionPane.showDialog(frame, 
                                                    getResourceString("linkClickedWindowTitle"),
                                                    getResourceString("linkClickedMessage") + " " + url.toString(),
                                                    HyperOptionPane.YES_NO_OPTION);
            if (choice == HyperOptionPane.YES) {
                try {
                    java.lang.Runtime.getRuntime().exec(ch.getBrowser() + " " + url);
                } catch (Exception ex) {}
            }
        }
        else if (!ask) {
            try {
                java.lang.Runtime.getRuntime().exec(ch.getBrowser() + " " + url);
            } catch (Exception ex) {}
        }
    }

    protected static void makeExecute(String command) {
        if (!command.trim().equals("") && command.trim().length() != 0) {
            pane.setCaretPosition(pane.getDocument().getLength());
            pane.replaceSelection("\n\r");
            mn8Run = new mn8ThreadedRun(jTabPane, command, mn8ThreadedRun.INTERPRET);
            mn8Run.start();
        }
    }

    private void setOutput() {
        mn8Interpreter.GLOBAL_OUT_STREAM = new ResultPrintStream(System.out);
        mn8Interpreter.GLOBAL_ERR_STREAM = new ErrorPrintStream(System.err);
    }

    protected static void setAnimation(boolean status) {
        if (!ch.getNavigationBarStatus()) {
            if (status) {
                smallicon.setIcon(MyResources.getImageIcon("animatedsmallicon"));
            }
            else if (!status) {
                smallicon.setIcon(MyResources.getImageIcon("staticsmallicon"));
            }
        }
        else if (ch.getNavigationBarStatus()) {
            if (status && (ch.getButtonDisplay().equals(iconsonly) || ch.getButtonDisplay().equals(textonly))) {
                smallicon.setIcon(MyResources.getImageIcon("animatedsmallicon"));
            }
            else if (status && ch.getButtonDisplay().equals(textandicons)) {
                largeicon.setIcon(MyResources.getImageIcon("animatedlargeicon"));
            }
            else if (!status && (ch.getButtonDisplay().equals(iconsonly) || ch.getButtonDisplay().equals(textonly))) {
                smallicon.setIcon(MyResources.getImageIcon("staticsmallicon"));
            }
            else if (!status && ch.getButtonDisplay().equals(textandicons)) {
                largeicon.setIcon(MyResources.getImageIcon("staticlargeicon"));
            }
        }
    }

    private final String menubar = "file edit view bookmarks help";
    private final String file = "new open submenuOpenRecent - save saveAs - exit";
    private final String edit = "undo redo - copy paste cut - selectAll - find replace goto - preferences";
    private final String view = "checkHTMLMode checkHighlight checkEditable - submenuNavBar submenuLF submenumn8";
    private final String NavBarSubMenuItems = "checkActive - radiotext radiotext&icons radioicons";
    private final String mn8SubMenuItems = "checkVerbose checkDebug";
    private final String help = "help about";
    private final String toolbar = "new open save - undo redo - copy paste cut - run stop - init";
    protected static final String navigationbar = "back forw reload";
    private static final String textonly = "TO";
    private static final String textandicons = "T+I";
    private static final String iconsonly = "IO";
    private final String TXTFile = "txt";
    private final String HTMLFile = "html; htm; shtml";
    private final String MN8File = "mn8";
    protected static final String prompt = "cmd:>";
    protected static final int navComboListLength = 20;
    protected static final String openRecentListFileName = "/.HyperPadOpenRecentList.xml";
    protected static final String bookmarksFileName = "/.HyperPadBookmarks.xml";
}
