/*
 * $COPYRIGHT$
 * $Id: HyperSourceKeyListener.java,v 1.4 2001/11/04 18:03:55 borzy Exp $
 *
 * Date        Author               Changes
 * Aug 3 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.text.html.HTMLDocument;
/**
 * Class meant to catch and interpret the key events for source mode.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.4 $ $Date: 2001/11/04 18:03:55 $
 * @see String
 */  
public class HyperSourceKeyListener implements KeyListener {
    javax.swing.JTextPane _tp;
    
    public HyperSourceKeyListener(java.awt.Component comp) {
        _tp = (javax.swing.JTextPane) comp;
        _tp.addKeyListener(this);
    }

    public void keyPressed(KeyEvent ke) {
        interpret(ke);
    }

    public void keyReleased(KeyEvent ke) {
    }

    public void keyTyped(KeyEvent ke) {
    }

    private void interpret(KeyEvent ke) {
        switch (ke.getKeyCode()) {
        case KeyEvent.VK_TAB:
            org.media.hyperpad.conf.ConfigHandler ch = new org.media.hyperpad.conf.ConfigHandler(HyperPanel.XMLpath);
            if (ch.getReplaceMode()) {
                for (int i = 0; i < Integer.valueOf(ch.getSpaceNumber()).intValue(); i++) {
                    _tp.replaceSelection(" ");
                }
                ke.setKeyCode(0);
            }
            break;
        case KeyEvent.VK_ESCAPE:
            ke.setKeyCode(0);
            int choice = HyperOptionPane.showDialog(HyperPanel.frame, 
                                                    HyperPanel.getResourceString("exitWindowTitle"),
                                                    HyperPanel.getResourceString("exitMessage"),
                                                    HyperOptionPane.YES_NO_OPTION);
            if (choice == HyperOptionPane.YES) {
                System.exit(0);
            }
            else {
                _tp.requestFocus();
            }
            break;
        }
    }
}
