/*
 * $COPYRIGHT$
 * $Id: MN8Filter.java,v 1.1 2001/06/03 17:25:28 borzy Exp $
 *
 * Date        Author               Changes
 * Jun 01 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.io.File;
import javax.swing.filechooser.FileFilter;
/**
 * Class to filter .mn8 files only.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.1 $ $Date: 2001/06/03 17:25:28 $
 * @see String
 */
public class MN8Filter extends FileFilter {
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }        
        String extension = getExtension(f);
        if (extension.equals("mn8")) { 
            return true; 
        }
        else {
            return false;
        }
    }
    
    public String getDescription() {
        return "mn8 files";
    }
    
    private String getExtension(File f) {
        String s = f.getName();
        int i = s.lastIndexOf('.');
        if (i > 0 && i < s.length() - 1) 
            return s.substring(i+1).toLowerCase();
        return "";
    }
}
