/*
 * $COPYRIGHT$
 * $Id: Main.java,v 1.4 2001/11/07 17:47:51 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */   
package org.media.hyperpad;

import java.io.InputStream;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import javax.swing.JFrame;
import javax.swing.ImageIcon;
/**
 * Class meant to start the HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.4 $ $Date: 2001/11/07 17:47:51 $
 * @see String
 */  
public class Main extends JFrame {
    HyperPanel hp = new HyperPanel();
    
    public Main() {
        super();
        setContentPane(hp.getContentPane());
        setTitle("HyperPad");
        setJMenuBar(hp.createMenubar());
        System.out.println("Done.");
        hp.init();
        Image apl_icon;
        try { 
            InputStream in = ClassLoader.getSystemResourceAsStream("org/media/hyperpad/res/apl_icon.gif"); 
            if (in == null) { 
                System.err.println("Image not found."); 
            } 
            byte[] buffer = new byte[in.available()]; 
            if (buffer.length == 1){
                int length = 0;
                while (in.read() != -1) { 
                    length++;
                }
                buffer = new byte[length];
                in.close();
                in = ClassLoader.getSystemResourceAsStream("org/media/hyperpad/res/apl_icon.gif");
            }
            in.read(buffer);
            apl_icon = Toolkit.getDefaultToolkit().createImage(buffer); 
            in.close();
            setIconImage(apl_icon);
        }
        catch (Exception e) { 
            System.err.println("Unable to read aplication icon, use default."); 
            e.printStackTrace(); 
        }
        setLocation(100,100);
        setSize(640,480);
        setVisible(true);
        addWindowListener(new WindowAdapter () {
            public void windowClosing(WindowEvent e){
                System.exit(0);
            }
        });
    }

    public static void main(String args[]){
        System.out.println("\n" + "HyperPad is loading, please wait...");
        Main m = new Main();
    }
}
