/*
 * $COPYRIGHT$
 * $Id: NavigatorBoxEditor.java,v 1.6 2001/11/10 16:35:32 borzy Exp $
 *
 * Date        Author               Changes
 * Aug 20 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.util.Vector;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.JComboBox;
import javax.swing.plaf.basic.BasicComboBoxEditor;
/**
 * This is a special editor for JComboBox used as a navigatorBox for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.6 $ $Date: 2001/11/10 16:35:32 $
 * @see String
 */        
public class NavigatorBoxEditor extends BasicComboBoxEditor {
    private boolean _isValidURL = false;
    boolean init = true;

    public NavigatorBoxEditor() {
        super();
        editor = new org.media.hyperpad.gui.HypTextField() {
            public void paste() {
                java.awt.datatransfer.Clipboard clipboard = java.awt.Toolkit.getDefaultToolkit().getSystemClipboard();
                java.awt.datatransfer.Transferable t = clipboard.getContents(this);
                try {
                    String content = (String)t.getTransferData(java.awt.datatransfer.DataFlavor.stringFlavor);
                    setItem(content.substring(0, content.indexOf("\n")));
                } catch (Exception ex) {}
            }
        };
        editor.addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent ke) {
                if (ke.getKeyCode() == KeyEvent.VK_ENTER && editor.getText().length() != 0) {
                    String current = editor.getText();
                    try {
                        java.net.URL url = new java.net.URL(current);
                        setItem(current);
                        _isValidURL = true;
                    }
                    catch (Exception ex) {
                        if (current.startsWith("/")) {
                            current = "file:" + current;
                            _isValidURL = true;
                        }
                    }
                    finally {
                        if (_isValidURL) {
                            HyperPanel.updateComboList(current);
                            setItem(current);
                            _isValidURL = false;
                        }
                    }
                }
            }
        });
    }

    public void setItem(Object obj) {
        if (init) {
            init = false;
        }
        else {
            super.setItem(obj);
        }
    }
}
