/*
 * $COPYRIGHT$
 * $Id: OpeningThread.java,v 1.6 2002/02/22 12:51:53 borzy Exp $
 *
 * Date        Author               Changes
 * Oct 03 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import javax.swing.JTabbedPane;
import javax.swing.JScrollPane;
import javax.swing.JFileChooser;
import javax.swing.JTextPane;
import javax.swing.text.html.HTMLDocument;
import org.media.mn8.mn8Interpreter;
import org.media.mn8.mn8Loader;
/**
 * Class meant to run the mn8 command execution in a separate thread from HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.6 $ $Date: 2002/02/22 12:51:53 $
 * @see String
 */  
public class OpeningThread extends Thread {
    private String _file, _shell;


    public  OpeningThread(String file_path, String shell_path) {
        _file = file_path;
        _shell = shell_path;
    }

    public void run() {
        java.io.BufferedReader in = null;
        int fileLength = 0;
        String content = "";
        if (null == _file && null != _shell) {
            try {
                HyperPanel.pane.setCaretPosition(HyperPanel.pane.getDocument().getLength());
                HyperPanel.pane.replaceSelection("\n\r");
                HyperPanel.mn8Run = new mn8ThreadedRun(HyperPanel.jTabPane, _shell, mn8ThreadedRun.EXECUTE);
                HyperPanel.mn8Run.start();
                HyperPanel._sourceDocPath = "Unknown"+_shell;
                HyperPanel.sourceDocSaved = true;
            } catch (Exception ex) {
                HyperOptionPane.showDialog(HyperPanel.frame, 
                                           "Error",
                                           "Script not found.",
                                           HyperOptionPane.DEFAULT_OPTION);
            }
        }
        else if (null == _file && null == _shell) {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileFilter(new MN8Filter());
            if (!HyperPanel._sourceDocPath.equals("Unknown")) {
                chooser.setCurrentDirectory(new java.io.File(HyperPanel._sourceDocPath));
            }
            int returnVal = chooser.showOpenDialog(HyperPanel.frame);
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                try {
                    in = new java.io.BufferedReader(new java.io.FileReader(chooser.getSelectedFile()));
                    fileLength = (int)chooser.getSelectedFile().getPath().length();
                    HyperPanel._sourceDocPath = chooser.getSelectedFile().getPath();
                    HyperPanel.sourceDocSaved = true;
                    HyperPanel.orlh.appendList(HyperPanel._sourceDocPath);
                    HyperPanel.updateOpenRecentMenu();
                }
                catch (Exception ex) {}
            }
        }
        else if (null != _file && null == _shell) {
            try {
                in = new java.io.BufferedReader(new java.io.FileReader(_file));
                fileLength = _file.length();
                HyperPanel._sourceDocPath = _file;
                HyperPanel.sourceDocSaved = true;
                HyperPanel.orlh.appendList(HyperPanel._sourceDocPath);
                HyperPanel.updateOpenRecentMenu();
            }
            catch (Exception ex) {
                HyperOptionPane.showDialog(HyperPanel.frame, 
                                           HyperPanel.getResourceString("fileNotFoundErrorWindowTitle"),
                                           HyperPanel.getResourceString("fileNotFoundErrorMessage"),
                                           HyperOptionPane.DEFAULT_OPTION);
            }
        }
        if (null != in) {
            try {
                HyperPanel.jLabel.setText("Loading...");
                HyperPanel.jTabPane.setSelectedIndex(1);
                ProgressThread pth = new ProgressThread("Loading text from file");
                pth.run();
                HyperPanel.prgBar.setMaximum(fileLength);
                String buffer = "";
                String line = in.readLine();
                while (line != null) {
                    buffer += line+"\n";
                    line = in.readLine();
                    HyperPanel.prgBar.setValue(buffer.length());
                }
                pth.kill();
                HyperSourceDocument.isLongInsert = true;
                HyperPanel.editorpane.select(0, HyperPanel.editorpane.getDocument().getLength());
                HyperPanel.editorpane.replaceSelection(buffer);
                HyperPanel.jLabel.setText("Ready");
                HyperPanel.editorpane.select(0, 0);
                HyperPanel.jTabPane.updateUI();
            } catch (Exception ex) {}
        }
        HyperPanel.updateSaveButton();
    }
}
