/*
 * $COPYRIGHT$
 * $Id: ProgressThread.java,v 1.1 2001/11/01 16:11:46 borzy Exp $
 *
 * Date        Author               Changes
 * Oct 03 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import java.awt.BorderLayout;
/**
 * Class meant to monitoring open and highlight in HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.1 $ $Date: 2001/11/01 16:11:46 $
 * @see String
 */  
public class ProgressThread extends Thread {
    private JFrame frame = new JFrame();
    private String _label = "";
    
    public ProgressThread(String label) {
        _label = label;
    }

    public void run() {
        frame.setTitle("Loading file...");
        HyperPanel.prgBar.setValue(0);
        HyperPanel.prgBar.updateUI();
        JLabel label = new JLabel(_label);
        JPanel panel = new JPanel(new BorderLayout());
        panel.add(label, BorderLayout.CENTER);
        panel.add(HyperPanel.prgBar, BorderLayout.SOUTH);
        panel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
        frame.getContentPane().add(panel);
        frame.pack();
        frame.setLocation((int)(HyperPanel.frame.getLocation().getX() + 
                          (HyperPanel.frame.getSize().getWidth() - frame.getSize().getWidth()) / 2),
                          (int)(HyperPanel.frame.getLocation().getY() + 
                          (HyperPanel.frame.getSize().getHeight() - frame.getSize().getHeight()) / 2));
        frame.setVisible(true);
    }

    public void kill() {
        frame.dispose();
    }
}
