/*
 * $COPYRIGHT$
 * $Id: RedoAction.java,v 1.2 2001/11/05 18:19:59 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.AbstractAction;
/**
 * Class meant to manage the redo events for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.2 $ $Date: 2001/11/05 18:19:59 $
 * @see String
 */ 
public class RedoAction extends AbstractAction {
    UndoHandler uh = null;

    public RedoAction(UndoHandler undohand) {
        super("Redo");
        setEnabled(false);
        uh = undohand;
    }
    
    public void actionPerformed(ActionEvent e) {
        if (HyperPanel.jTabPane.getSelectedIndex() == 0) {
            try {
                uh.undo.redo();
                uh.refresh(uh.doc);
            } catch (Exception ex) {}
            update(uh.doc);
            uh.undoAction.update(uh.doc);
        }
        else if (HyperPanel.jTabPane.getSelectedIndex() == 1) {
            try {
                uh.sourceUndo.redo();
                uh.refresh(uh.sourceDoc);
            } catch (Exception ex) {}
            update(uh.sourceDoc);
            uh.undoAction.update(uh.sourceDoc);
        }
    }
    
    protected void update(int source) {
        if (uh.starting) {
            uh.starting = false;
        }
        else {
            if (source == uh.doc) {
                if(uh.undo.canRedo()) {
                    setEnabled(true);
                    putValue(Action.NAME, uh.undo.getRedoPresentationName());
                    uh.setRedo(true);
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Redo");
                    uh.setRedo(false);
                }
            }
            else if (source == uh.sourceDoc) {
                if(uh.sourceUndo.canRedo()) {
                    setEnabled(true);
                    putValue(Action.NAME, uh.sourceUndo.getRedoPresentationName());
                    uh.setRedo(true);
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Redo");
                    uh.setRedo(false);
                }
            }
        }
    }
}
