/*
 * $COPYRIGHT$
 * $Id: ResultPrintStream.java,v 1.17 2002/06/04 18:16:40 borzy Exp $
 *
 * Date        Author               Changes
 * Aug 11 2001 Borsos Szabolcs      Created
 */
package org.media.hyperpad;

import java.io.PrintStream;
import java.io.OutputStream;
import org.media.hyperpad.conf.*;
import org.media.mn8.mn8Interpreter;
/**
 * Class meant to display the results witch are returned by mn8.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.17 $ $Date: 2002/06/04 18:16:40 $
 * @see String
 */
public class ResultPrintStream extends PrintStream {
    final static String RESULT = "result";
    private static ConfigHandler ch = null;
    private static HyperDocument hp;
    static boolean isResult = false;
    static String all = "";
    boolean EndOfResult = false;
    
    public ResultPrintStream(OutputStream out) {
        super(out);
        ch = HyperPanel.ch;
        hp = (HyperDocument) HyperPanel.pane.getDocument();
    }

    public void println(String string) {
        if (string.equals(mn8Interpreter.EOL)) {
            EndOfResult = true;
        }
        displayResults(string); 
    }

    public void print(String string) {
        if (string.equals(mn8Interpreter.EOL)) {
            EndOfResult = true;
        }
        displayResults(string); 
    }

    private void displayResults(String results) {
        String result = null;
        if (!ch.getHTMLMode()){
            StringBuffer buffer = new StringBuffer(results);
            for (int i=0; i<buffer.length(); i++) {
                char c = buffer.charAt(i);
                if (c == '<') {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "&lt;");
                    i += 3;
                }
                else if (c == '>') {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "&gt;");
                    i += 3;
                }
                else if (c == ' ') {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "&nbsp;");
                    i += 5;
                }
                else if (c == '\"') {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "&quot;");
                    i += 5;
                }
                else if (c == '\n') {
                    buffer.deleteCharAt(i);
                    buffer.insert(i, "<br>");
                    i += 3;
                }
                else if (c == '\r') {
                    if (buffer.charAt(i+1) == '\n') {
                        buffer.deleteCharAt(i);
                        buffer.deleteCharAt(i);
                        buffer.insert(i, "<br>");
                        i += 2;
                    }
                    else {
                        buffer.deleteCharAt(i);
                        buffer.insert(i, "<br>");
                        i += 3;
                    }
                }
            }
            result = buffer.toString();
        }
        else {
            result = results;
            EndOfResult = true;
        }
        if (result.trim().length() != 0) {
            isResult = true;
        }
        try {                    
            if (EndOfResult) {
                all += result;
                hp.insertString(hp.getLength(), RESULT+all, null);
                HyperPanel.pane.setCaretPosition(hp.getLength());
                all = "";
                EndOfResult = false;
            }
            else {
                all += result;
            }
        } catch (Exception ex) {}
    }
}

