/*
 * $COPYRIGHT$
 * $Id: UndoAction.java,v 1.2 2001/11/05 18:20:10 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import java.awt.event.ActionEvent;
import javax.swing.Action;
import javax.swing.AbstractAction;
/**
 * Class meant to manage the undo events for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.2 $ $Date: 2001/11/05 18:20:10 $
 * @see String
 */ 
public class UndoAction extends AbstractAction {
    UndoHandler uh = null;

    public UndoAction(UndoHandler undohand) {
        super("Undo");
        setEnabled(false);
        uh = undohand;
    }
    
    public void actionPerformed(ActionEvent e) {
        if (HyperPanel.jTabPane.getSelectedIndex() == 0) {
            try {
                uh.undo.undo();
                uh.refresh(uh.doc);
            } catch (Exception ex) {}
            update(uh.doc);
            uh.redoAction.update(uh.doc);
        }
        else if (HyperPanel.jTabPane.getSelectedIndex() == 1) {
            try {
                uh.sourceUndo.undo();
                uh.refresh(uh.sourceDoc);
            } catch (Exception ex) {}
            update(uh.sourceDoc);
            uh.redoAction.update(uh.sourceDoc);
        }
    }
    
    protected void update(int source) {
        if (!uh.starting) {
            if (source == uh.doc) {
                if(uh.undo.canUndo()) {
                    setEnabled(true);
                    putValue(Action.NAME, uh.undo.getUndoPresentationName());
                    uh.setUndo(true);
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Undo");
                    uh.setUndo(false);
                }
            }
            else if (source == uh.sourceDoc) {
                if(uh.sourceUndo.canUndo()) {
                    setEnabled(true);
                    putValue(Action.NAME, uh.sourceUndo.getUndoPresentationName());
                    uh.setUndo(true);
                }
                else {
                    setEnabled(false);
                    putValue(Action.NAME, "Undo");
                    uh.setUndo(false);
                }
            }
        }
    }
}
