/*
 * $COPYRIGHT$
 * $Id: UndoHandler.java,v 1.2 2001/08/10 10:58:44 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */      
package org.media.hyperpad;

import javax.swing.Action;
import javax.swing.event.UndoableEditEvent;
import javax.swing.event.UndoableEditListener;
import javax.swing.undo.UndoManager;
/**
 * Class meant to handle the edit events for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.2 $ $Date: 2001/08/10 10:58:44 $
 * @see String
 */ 
public class UndoHandler implements UndoableEditListener {
    UndoAction undoAction = new UndoAction(this);
    RedoAction redoAction = new RedoAction(this);
    UndoManager undo = new UndoManager();
    UndoManager sourceUndo = new UndoManager();
    boolean starting = true;
    static int offset = 0;
    static int sourceOffset = 0;
    final int doc = 0;
    final int sourceDoc = 1;

    public void undoableEditHappened(UndoableEditEvent e) {
        if (e.getSource().equals(HyperPanel.pane.getDocument())) {
            if (HyperPanel.documentLength != HyperPanel.pane.getDocument().getLength()) {
                undo.addEdit(e.getEdit());
                undoAction.update(doc);
                redoAction.update(doc);
            }
        }
        else if (e.getSource().equals(HyperPanel.editorpane.getDocument())) {
            if (HyperPanel.sourceDocumentLength != HyperPanel.editorpane.getDocument().getLength()) {
                sourceUndo.addEdit(e.getEdit());
                undoAction.update(sourceDoc);
                redoAction.update(sourceDoc);
            }
        }
    }

    protected void refresh(int source) {
        try {
            if (source == doc) {
                if (offset == 0) {
                    offset += HyperPanel.prompt.length();
                }
                HyperPanel.pane.getDocument().insertString(offset, "", null);
            }
            else if (source == sourceDoc) {
                HyperPanel.editorpane.getDocument().insertString(sourceOffset, "", null);
            }
        } catch (Exception ex) {}
    }

    protected void updateUndo() {
        if (HyperPanel.jTabPane.getSelectedIndex() == 0) {
            if(undo.canUndo()) {
                setUndo(true);
            }
            else {
                setUndo(false);
            }
        }
        else if (HyperPanel.jTabPane.getSelectedIndex() == 1) {
            if(sourceUndo.canUndo()) {
                setUndo(true);
            }
            else {
                setUndo(false);
            }
        }
    }

    protected void updateRedo() {
        if (HyperPanel.jTabPane.getSelectedIndex() == 0) {
            if(undo.canRedo()) {
                setRedo(true);
            }
            else {
                setRedo(false);
            }
        }
        else if (HyperPanel.jTabPane.getSelectedIndex() == 1) {
            if(sourceUndo.canRedo()) {
                setRedo(true);
            }
            else {
                setRedo(false);
            }
        }
    }

    protected void setUndo(boolean status) {
        HyperPanel.undoMenu.setEnabled(status);
        HyperPanel.undoButton.setEnabled(status);
    }

    protected void setRedo(boolean status) {
        HyperPanel.redoMenu.setEnabled(status);
        HyperPanel.redoButton.setEnabled(status);
    }
}
