/*
 * $COPYRIGHT$
 * $Id: ComboHandler.java,v 1.2 2001/11/13 16:00:42 borzy Exp $
 *
 * Date        Author               Changes
 * Aug 16 2001 Borsos Szabolcs      Created
 */   
package org.media.hyperpad.conf;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import org.w3c.dom.*;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.FactoryConfigurationError;  
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.DocumentBuilder;
/**
 * Class meant to handle the ComboBox list for HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.2 $ $Date: 2001/11/13 16:00:42 $
 * @see String
 */  
public class ComboHandler {
    Document document;
    InputSource is;
    Element e;
        
    public ComboHandler() {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            InputStream ins = getXML(getXMLPath());
            if (ins != null) {
                is = new InputSource(ins);
                DocumentBuilder builder = factory.newDocumentBuilder();
                document = builder.parse(is); 
                e = document.getDocumentElement();
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private InputStream getXML(String path) throws IOException {
        try {
            Class _this = Class.forName("org.media.hyperpad.conf.ComboHandler");
            InputStream ins = (InputStream)new FileInputStream(path);
            if (ins != null) {
                return ins;
            }
            else {
                System.out.println("Wrong path given to ComboHandler. "+path);
                return null;
            }
        }
        catch (ClassNotFoundException cnfex) {
            System.out.println("Can't find the combolist XML file!");
            cnfex.printStackTrace();
            return null;
        }
    }

    public String getListItem(int itemNR) {
        return getItem("item"+itemNR, "value");
    }

    public void setListItem(int itemNR, String new_value) {
        setItem("item"+itemNR, "value", new_value);
    }

    public void save() {
        ConfigHandler.saveXML(getXMLPath(), document, e);
    }

    private String getItem(String node, String element) {
        String value = null;
        NodeList nl = e.getElementsByTagName(node);
        Element elem = (Element) nl.item(0);
        value = elem.getAttribute(element);
        return value;
    }

    private void setItem(String node, String element, String new_value) {
        NodeList nl = e.getElementsByTagName(node);
        Element elem = (Element) nl.item(0);
        elem.removeAttribute(element);
        elem.setAttribute(element, new_value);
    }

    private String getXMLPath() {
        try {
            Class _this = Class.forName("org.media.hyperpad.conf.ComboHandler");
            String urlpath = _this.getResource("/conf/combolist.xml").toString();
            return urlpath.substring(5, urlpath.length());
        } catch (Exception ex) {
            ex.printStackTrace();
            return "";
        }
    }
}
