/*
 * $COPYRIGHT$
 * $Id: HypComboBox.java,v 1.2 2001/10/17 15:53:11 borzy Exp $
 *
 * Date        Author               Changes
 * Oct 15 2001 Borsos Szabolcs      Created
 */
package org.media.hyperpad.gui;

import javax.swing.JComboBox;
import javax.swing.ComboBoxModel;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.RenderingHints;
import java.awt.Graphics2D;
import org.media.hyperpad.HyperPanel;
import org.media.hyperpad.NavigatorBoxCellRenderer;
/**
 * Class needed by HyperPad for antialiased components.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.2 $ $Date: 2001/10/17 15:53:11 $
 * @see String
 */
public class HypComboBox extends JComboBox {
    
    public  HypComboBox() {
        super();
        setRenderer(new NavigatorBoxCellRenderer());
    }

    public HypComboBox(ComboBoxModel aModel) {
        super(aModel);
        setRenderer(new NavigatorBoxCellRenderer());
    }

    public HypComboBox(Vector items) {
        super(items);
        setRenderer(new NavigatorBoxCellRenderer());
    }

    public void paint(Graphics g) {
        if (((Boolean)HyperPanel.confcache.get(HyperPanel.confcache.isAntiAliasing)).booleanValue() &&
            isEditable) {
            ((Graphics2D) g).setRenderingHints
                ((RenderingHints)HyperPanel.confcache.get(HyperPanel.confcache.ANTI_ALIASED_RENDERING));
        }
        else {
            ((Graphics2D) g).setRenderingHints
                ((RenderingHints)HyperPanel.confcache.get(HyperPanel.confcache.DEFAULT_RENDERING));
        }
        super.paint(g);
    }

}
