/*
 * $COPYRIGHT$
 * $Id: HypTextPane.java,v 1.3 2002/01/23 17:20:37 borzy Exp $
 *
 * Date        Author               Changes
 * Oct 15 2001 Borsos Szabolcs      Created
 */
package org.media.hyperpad.gui;

import javax.swing.JTextPane;
import javax.swing.text.StyledDocument;
import java.util.Vector;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.RenderingHints;
import java.awt.Graphics2D;
import org.media.hyperpad.HyperPanel;
/**
 * Class needed by HyperPad for antialiased components.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.3 $ $Date: 2002/01/23 17:20:37 $
 * @see String
 */
public class HypTextPane extends JTextPane {
    public final static int NO_LINE_WRAP = 0;
    public final static int LINE_WRAP = 1;
    private int _type = 0;

    public  HypTextPane() {
        super();
    }

    public  HypTextPane(int type) {
        super();
        _type = type;
    }

    public HypTextPane(StyledDocument doc, int type) {
        super(doc);
        _type = type;
    }

    public boolean getScrollableTracksViewportWidth () {
        if (_type == LINE_WRAP) {
            if (((Boolean)HyperPanel.confcache.get(HyperPanel.confcache.isLineWrap)).booleanValue()) {
                return true;
            }
            else {
                return false ;
            }
        }
        else {
            return true;
        }
    }

    public void setSize(Dimension d) {
        if (_type == LINE_WRAP) {
            if (d.width < getParent().getSize().width) {
                d.width = getParent().getSize().width;
            }
        }
        super.setSize(d);
    }

    public void paint(Graphics g) {
        if (((Boolean)HyperPanel.confcache.get(HyperPanel.confcache.isAntiAliasing)).booleanValue()) {
            ((Graphics2D) g).setRenderingHints
                ((RenderingHints)HyperPanel.confcache.get(HyperPanel.confcache.ANTI_ALIASED_RENDERING));
        }
        else {
            ((Graphics2D) g).setRenderingHints
                ((RenderingHints)HyperPanel.confcache.get(HyperPanel.confcache.DEFAULT_RENDERING));
        }
        super.paint(g);
    }

}
