/*
 * $COPYRIGHT$
 * $Id: mn8ThreadedRun.java,v 1.9 2002/04/30 18:47:31 borzy Exp $
 *
 * Date        Author               Changes
 * Oct 03 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad;

import javax.swing.JTabbedPane;
import javax.swing.JScrollPane;
import javax.swing.JViewport;
import javax.swing.JTextPane;
import javax.swing.text.html.HTMLDocument;
import org.media.mn8.mn8Interpreter;
import org.media.mn8.mn8Loader;
/**
 * Class meant to run the mn8 command execution in a separate thread from HyperPad.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.9 $ $Date: 2002/04/30 18:47:31 $
 * @see String
 */  
public class mn8ThreadedRun extends Thread {
    static final int INTERPRET = 0;
    static final int EXECUTE = 1;
    private JTabbedPane _jtp;
    private JTextPane iMode, eMode;
    private String _command;
    private int _type;
    
    public mn8ThreadedRun(JTabbedPane jTabPane, String command, int type) {
        _jtp = jTabPane;
        _command = command;
        _type = type;
        iMode = getTextPaneAt(_jtp, 0);
        eMode = getTextPaneAt(_jtp, 1);
    }

    public void kill() {
        mn8Interpreter.interruptInterpret();
    }

    public void run() {
        _jtp.setSelectedIndex(0);
        iMode.setCaretPosition(iMode.getDocument().getLength());
        HyperPanel.setAnimation(true);
        HyperPanel.stopButton.setEnabled(true);
        HyperPanel.jLabel.setText("Running...");
        if (_type == INTERPRET) {
            mn8Interpreter.interpret(_command);
        }
        else if (_type == EXECUTE) {
            String url = "";
            org.media.mn8.concepts.SeriesConcept param = new org.media.mn8.concepts.SeriesConcept();
            if (_command.indexOf(" ") > -1) {
                java.util.StringTokenizer st = new java.util.StringTokenizer(_command, " ");
                int nr = st.countTokens();
                for (int i=0; i < nr; i++) {
                    String token = st.nextToken();
                    if (i == 0) {
                        url = token;
                    }
                    else {
                        param.add(new org.media.mn8.concepts.StringConcept(token));
                    }
                }
            }
            else {
                url = _command;
                param.add(new org.media.mn8.concepts.SeriesConcept());
            }

            String content = mn8Loader.getContent(url);
            eMode.select(0, eMode.getDocument().getLength());
            eMode.replaceSelection(content);
            org.media.mn8.concepts.SeriesConcept args = new org.media.mn8.concepts.SeriesConcept();
            args.add(param);
            mn8Interpreter.executeURL(url, args);
        }

        HyperPanel.setAnimation(false);
        HyperPanel.running(false);
        HyperPanel.jLabel.setText("Ready");
        if (HyperPanel.iactivDocSaved) {
            HyperPanel.iactivDocSaved = false;
            HyperPanel.updateSaveButton();
        }
        if (ResultPrintStream.isResult) {
            HyperPanel.pane.replaceSelection("\n\r");
        }
        ResultPrintStream.isResult = false;
        ((HyperDocument)iMode.getDocument()).insertPrompt();
        HyperPanel.pane.setCaretPosition(iMode.getDocument().getLength()); 
    }

    private JTextPane getTextPaneAt(JTabbedPane jtp, int index) {
        JScrollPane jsp = (JScrollPane)jtp.getComponentAt(index);
        JViewport jwp = (JViewport)jsp.getComponent(0);
        return (JTextPane)jwp.getComponent(0);
    }
}
