/*
 * $COPYRIGHT$
 * $Id: ResBundleTest.java,v 1.13 2001/12/07 12:34:48 borzy Exp $
 *
 * Date        Author               Changes
 * Apr 18 2001 Borsos Szabolcs      Created
 */  
package org.media.hyperpad.test.hyperpanel;

import junit.framework.*;
import org.media.hyperpad.MyResources;
/**
 * Class meant to test all the returned result for Resource Bundle.
 * @author <a href="mailto:borzy@nolimits.ro">Borsos Szabolcs</a>
 * @version $Revision: 1.13 $ $Date: 2001/12/07 12:34:48 $
 * @see String
 */   
public class ResBundleTest extends TestCase {

    public ResBundleTest(String name) {
        super(name);
    }
    
    public static void main (String args[]) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        return new TestSuite(ResBundleTest.class);
    }
    
    protected void setUp() {
    }

    public void testFile_mi1() {
        assertEquals("File", MyResources.getLabels("fileLabel"));
    }

    public void testFile_mi2() {
        assertEquals("Open", MyResources.getLabels("openLabel"));
    }

    public void testFile_mi3() {	
        assertEquals("Save", MyResources.getLabels("saveLabel"));
    }
    
    public void testFile_mi4() {	
        assertEquals("Exit", MyResources.getLabels("exitLabel"));
    }
    
    public void testEdit_mi() {	
        assertEquals("Edit", MyResources.getLabels("editLabel"));
    }
    
    public void testEdit_mi1() {
        assertEquals("Copy", MyResources.getLabels("copyLabel"));
    }
    
    public void testEdit_mi2() {
        assertEquals("Paste", MyResources.getLabels("pasteLabel"));
    }
    
    public void testEdit_mi3() {
        assertEquals("Cut", MyResources.getLabels("cutLabel"));
    }
    
    public void testEdit_mi4() {
        assertEquals("Preferences...", MyResources.getLabels("preferencesLabel"));
    }

    public void testView_mi() {
        assertEquals("View", MyResources.getLabels("viewLabel"));
    }

    public void testView_m1() {
        assertEquals("HTML Mode", MyResources.getLabels("checkHTMLModeLabel"));
    }

    public void testHelp_mi1() {
        assertEquals("Help", MyResources.getLabels("helpLabel"));
    }
    
    public void testHelp_mi2() {
        assertEquals("About", MyResources.getLabels("aboutLabel"));
    }

    public void testTab_1() {
        assertEquals("Interactive Mode", MyResources.getTextValue("tab_1"));
    }

    public void testTab_2() {
        assertEquals("Source Editor", MyResources.getTextValue("tab_2"));
    }
}
